VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "X3BMedia"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Declare Function mciSendString Lib "winmm.dll" Alias "mciSendStringA" (ByVal lpstrCommand As String, ByVal lpstrReturnString As String, ByVal uReturnLength As Long, ByVal hwndCallback As Long) As Long
Private Declare Sub CoCreateGuid Lib "ole32.dll" (ByVal pguid As Long)
Private Const S_OK As Long = 0

Private m_szPath   As String
Private m_szAlias  As String
Private m_szTag    As String

'--X3Media
'--open {file path} alias {alias} type {media type}
'--Open a media file/device.
'--"waveaudio" for .wav files, "MPEGVideo" for everything else
'--
'--set {alias} time format milliseconds
'--Use millisecond timeformat, can also be frames
'--
'--set {alias} seek exactly on
'--Navigate to the specified frame, not the one before it
Public Function openMedia(ByRef szPath As String, Optional ByVal szType As String = "") As Boolean
    Dim szAlias As String, bGUIDArr(15) As Byte, i As Integer, lRet As Long
    
    Call closeMedia
    Call CoCreateGuid(VarPtr(bGUIDArr(0)))
    For i = 0 To 15 Step 1
        szAlias = szAlias + Right("0" + Hex(bGUIDArr(i)), 2)
    Next i
    If (szType = "") Then
        If (LCase(Right(szPath, 4)) = ".wav") Then szType = "waveaudio" Else szType = "MPEGVideo"
    End If
    
    openMedia = (mciSendString("open " + Chr(34) + szPath + Chr(34) + " alias " + szAlias + " type " + szType, vbNullString, 0, 0) = S_OK)
    If (openMedia) Then
        lRet = mciSendString("set " + szAlias + " time format milliseconds", vbNullString, 0, 0)
        lRet = mciSendString("set " + szAlias + " seek exactly on", vbNullString, 0, 0)
        m_szAlias = szAlias
        m_szPath = szPath
    End If
End Function

'--play/pause/resume/stop {alias} wait
'--Wait is used so the operation completes before the function returns
Public Function playMedia(ByVal bWait As Boolean) As Boolean
    playMedia = (mciSendString("play " + m_szAlias + IIf((bWait), " wait", ""), vbNullString, 0, 0) = S_OK)
End Function

Public Function pauseMedia() As Boolean
    pauseMedia = (mciSendString("pause " + m_szAlias + " wait", vbNullString, 0, 0) = S_OK)
End Function

Public Function resumeMedia() As Boolean
    resumeMedia = (mciSendString("resume " + m_szAlias + " wait", vbNullString, 0, 0) = S_OK)
End Function

Public Function stopMedia() As Boolean
    stopMedia = (mciSendString("stop " + m_szAlias + " wait", vbNullString, 0, 0) = S_OK)
End Function

'--seek {alias} {start/end/xxx} wait
'--xxx means a numeric position based on the timeformat
Public Function seekMedia(ByVal lPos As Long) As Boolean
    Dim szPos As String
    
    If (lPos = 0) Then
        szPos = "start"
    ElseIf (lPos = -1) Then
        szPos = "end"
    Else
        szPos = CStr(lPos)
    End If
    seekMedia = (mciSendString("seek " + m_szAlias + " to " + szPos + " wait", vbNullString, 0, 0) = S_OK)
End Function

'--Render the video on a hWnd
'--window {alias} handle default
'--Place the video on it own top-level window
'--
'--window {alias} hWnd wait
'--Plave the video on the specified hWnd
Public Function setVideoDestination(ByVal hWnd As Long) As Boolean
    Dim szCmd As String
    
    If (hWnd = 0) Then szCmd = "window " + m_szAlias + " handle default" Else szCmd = "window " + m_szAlias + " handle " + CStr(hWnd)
    setVideoDestination = (mciSendString(szCmd + " wait", vbNullString, 0, 0) = S_OK)
End Function

'--put {alias} destination at X Y W H
'--Position the window on a specified hWnd at X Y W H
Public Function setVideoDestinationEx(ByVal hwndParent As Long, ByVal lX As Long, ByVal lY As Long, ByVal lW As Long, ByVal lH As Long) As Boolean
    setVideoDestinationEx = setVideoDestination(hwndParent)
    If (hwndParent) Then
        setVideoDestinationEx = (mciSendString("put " + m_szAlias + " destination at " & lX & " " & lY & " " & lW & " " & lH & " wait", vbNullString, 0, 0) = S_OK)
    End If
End Function

'--close {alias}
'--Closes the media and releases resources
Public Function closeMedia() As Boolean
    Call stopMedia
    closeMedia = (mciSendString("close " + m_szAlias, vbNullString, 0, 0) = S_OK)
End Function

'--To make this call extensible...
Public Function sendCommand(ByVal szCmd As String, ByRef szRetBuff As String) As Boolean
    sendCommand = (mciSendString(szCmd, szRetBuff, Len(szRetBuff), 0) = S_OK)
End Function

'--status {alias} length wait
'--Get the length of the media based on the time format
Public Property Get Length() As Long
    Dim szRet As String
    
    szRet = String(16, vbNullChar)
    If (mciSendString("status " + m_szAlias + " length wait", szRet, Len(szRet), 0) = S_OK) Then
        Length = CLng(Replace(szRet, vbNullChar, ""))
    Else
        Length = (-1)
    End If
End Property

'--status {alias} position wait
'--Get the current media position based on the time format
Public Property Get Position() As Long
    Dim szRet As String
    
    szRet = String(16, vbNullChar)
    If (mciSendString("status " + m_szAlias + " position wait", szRet, Len(szRet), 0) = S_OK) Then
        Position = CLng(Replace(szRet, vbNullChar, ""))
    Else
        Position = (-1)
    End If
End Property

Private Sub Class_Terminate()
    Call closeMedia
End Sub

Public Property Get Alias() As String
    Alias = m_szAlias
End Property

Public Property Get Media() As String
    Media = m_szPath
End Property

Public Property Get Tag() As String
    Tag = m_szTag
End Property
Public Property Let Tag(ByVal szVal As String)
    m_szTag = szVal
End Property










