VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "X3BMenu"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Declare Function CreatePopupMenu Lib "user32.dll" () As Long
Private Declare Function TrackPopupMenu Lib "user32.dll" (ByVal hMenu As Long, ByVal wFlags As Long, ByVal x As Long, ByVal y As Long, ByVal nReserved As Long, ByVal hWnd As Long, ByRef lprcAsRECT As Any) As Long
Private Declare Function DestroyMenu Lib "user32.dll" (ByVal hMenu As Long) As Long
Private Declare Function InsertMenuItem Lib "user32.dll" Alias "InsertMenuItemA" (ByVal hMenu As Long, ByVal un As Long, ByVal bool As Boolean, ByRef lpcMenuItemInfo As MENUITEMINFO) As Long
Private Declare Function SetMenuItemInfo Lib "user32.dll" Alias "SetMenuItemInfoA" (ByVal hMenu As Long, ByVal un As Long, ByVal bool As Boolean, ByRef lpcMenuItemInfo As MENUITEMINFO) As Long
Private Declare Function GetMenuCheckMarkDimensions Lib "user32.dll" () As Long
Private Declare Function GetMenuItemInfo Lib "user32.dll" Alias "GetMenuItemInfoA" (ByVal hMenu As Long, ByVal un As Long, ByVal b As Boolean, ByRef lpMenuItemInfo As MENUITEMINFO) As Long
Private Declare Function DefWindowProc Lib "user32.dll" Alias "DefWindowProcA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

Private Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" (ByRef Destination As Any, ByRef Source As Any, ByVal Length As Long)

Private Type MENUITEMINFO
    cbSize        As Long
    fMask         As Long
    fType         As Long
    fState        As Long
    wID           As Long
    hSubMenu      As Long
    hbmpChecked   As Long
    hbmpUnchecked As Long
    dwItemData    As Long
    dwTypeData    As String
    cch           As Long
    hBmpItem      As Long
End Type

Private Type RECT
    Left   As Long
    Top    As Long
    Right  As Long
    Bottom As Long
End Type

Private Const WM_DRAWITEM    As Long = &H2B
Private Const WM_MEASUREITEM As Long = &H2C

Private Type MEASUREITEMSTRUCT
    CtlType    As Long
    CtlID      As Long
    itemID     As Long
    itemWidth  As Long
    itemHeight As Long
    itemData   As Long
End Type

Private Type DRAWITEMSTRUCT
    CtlType    As Long
    CtlID      As Long
    itemID     As Long
    itemAction As Long
    itemState  As Long
    hwndItem   As Long
    hdc        As Long
    rcItem     As RECT
    itemData   As Long
End Type
  
Private Const MIIM_ID         As Long = &H2
Private Const MIIM_STATE      As Long = &H1
Private Const MIIM_STRING     As Long = &H40
Private Const MIIM_FTYPE      As Long = &H100
Private Const MIIM_CHECKMARKS As Long = &H8
Private Const MIIM_BITMAP     As Long = &H80

Private Const MFT_OWNERDRAW As Long = &H100&
Private Const MFT_SEPARATOR As Long = &H800&

Private Const MFS_DISABLED  As Long = &H3&
Private Const MFS_CHECKED   As Long = &H8&
Private Const MFS_DEFAULT   As Long = &H1000&
Private Const MFS_ENABLED   As Long = &H0&
Private Const MFS_GRAYED    As Long = &H3&
Private Const MFS_HILITE    As Long = &H80&
Private Const MFS_UNCHECKED As Long = &H0&
Private Const MFS_UNHILITE  As Long = &H0&

Private Const TPM_LEFTALIGN       As Long = &H0&
Private Const TPM_CENTERALIGN     As Long = &H4&
Private Const TPM_RETURNCMD       As Long = &H100&
Private Const TPM_VERPOSANIMATION As Long = &H1000&
Private Const TPM_TOPALIGN        As Long = &H0&
Private Const TPM_RIGHTBUTTON     As Long = &H2&
Private Const TPM_LEFTBUTTON      As Long = &H0&
Private Const TPM_RIGHTALIGN      As Long = &H8&

Private Const ODT_MENU As Long = 1

Public Enum EOwnerDrawState
    ODS_DISABLED = &H4
    ODS_GRAYED = &H2
    ODS_SELECTED = &H1
    ODS_CHECKED = &H8
    ODS_DEFAULT = &H20
End Enum

Public Enum EAlignment
    ALIGN_LEFT = TPM_LEFTALIGN
    ALIGN_CENTER = TPM_CENTERALIGN
    ALIGN_RIGHT = TPM_RIGHTALIGN
End Enum

Public Event measureItem(ByRef lW As Long, ByRef lH As Long, ByVal lData As Long, ByVal nID As Integer)
Public Event drawItem(ByVal lpDrawItemStruct As Long)

Private m_hMenu                  As Long
Private m_oTxtPrinter            As X3TextPrinter
Private m_oCheckmarkIconsArr()   As X3BIcon
Private m_szItemArr()            As String
Private m_hBmpArr()              As Long
Private m_szTag                  As String

Private Sub Class_Initialize()
    Dim oFnt As StdFont
    
    Set oFnt = New StdFont
    oFnt.Name = "Arial"
    oFnt.Size = 13
    Set m_oTxtPrinter = New X3TextPrinter
    Call m_oTxtPrinter.setFontFromStdFont(oFnt)
End Sub

Private Sub Class_Terminate()
    Call deleteMenu
End Sub

Public Function fillDrawItemStruct(ByVal lpDISDest As Long, ByVal lpDISSrc As Long)
    Dim tDI As DRAWITEMSTRUCT
    Call CopyMemory(ByVal lpDISDest, ByVal lpDISSrc, Len(tDI))
End Function

Public Function setFont(ByVal oFnt As StdFont)
    Set m_oTxtPrinter = New X3TextPrinter
    Call m_oTxtPrinter.setFontFromStdFont(oFnt)
End Function

Public Function setMenuItemText(ParamArray vszItemArr() As Variant)
    Dim nCnt As Integer, i As Integer
    
    nCnt = UBound(vszItemArr)
    ReDim m_szItemArr(nCnt)
    For i = 0 To nCnt Step 1
        If ((IsEmpty(vszItemArr(i))) Or (IsMissing(vszItemArr(i)))) Then vszItemArr(i) = ""
        m_szItemArr(i) = vszItemArr(i)
    Next i
End Function

Public Function getMenuItemText(ByVal nIndx As String) As String
    getMenuItemText = m_szItemArr(nIndx)
End Function

Public Function setMenuItemTextByID(ByVal nID As Integer, ByVal szText As String)
    m_szItemArr(nID - 1) = szText
End Function

Public Function setMenuItemTextByArray(ByRef szItemArr() As String)
    Dim i As Integer
    
    ReDim m_szItemArr(UBound(szItemArr))
    For i = 0 To UBound(szItemArr) Step 1
        m_szItemArr(i) = szItemArr(i)
    Next i
End Function

Public Function setCheckmarkIcons(ParamArray voIconsArr() As Variant)
    Dim nCnt As Integer, i As Integer
    
    nCnt = UBound(voIconsArr)
    ReDim m_oCheckmarkIconsArr(nCnt)
    For i = 0 To nCnt Step 1
        If ((Not IsEmpty(voIconsArr(i))) And (Not IsMissing(voIconsArr(i)))) Then
            Set m_oCheckmarkIconsArr(i) = voIconsArr(i)
        Else
            Set m_oCheckmarkIconsArr(i) = Nothing
        End If
    Next i
End Function

Public Function hasState(ByVal lODS As Long, ByVal eODS As EOwnerDrawState)
    '--Check for an OwnerDrawState flag with a bitwise check
    hasState = ((lODS And eODS) = eODS)
End Function

Public Function setMenuItemEnabled(ByVal nID As Integer, ByRef bEnable As Boolean)
    Call setStateFlag(nID, MFS_ENABLED, MFS_DISABLED, bEnable)
End Function

Public Function setMenuItemChecked(ByVal nID As Integer, ByRef bChecked As Boolean)
    Call setStateFlag(nID, MFS_CHECKED, MFS_UNCHECKED, bChecked)
End Function

Public Function setMenuItemSelected(ByVal nID As Integer, ByRef bSelected As Boolean)
    Call setStateFlag(nID, MFS_HILITE, MFS_UNHILITE, bSelected)
End Function

Public Function setMenuItemOwnerDrawStatusForAll(ByVal bOwnerDraw As Boolean)
    Dim i As Integer
    
    For i = 1 To MenuItemCount Step 1
        Call setMenuItemOwnerDrawStatus(i, bOwnerDraw)
    Next i
End Function

Public Function setMenuItemOwnerDrawStatus(ByVal nID As Integer, ByVal bOwnerDraw As Boolean)
    Dim tMIIOwnerDraw As MENUITEMINFO, lRet As Long
    
    '--Enable or disable owner draw menu flag
    With tMIIOwnerDraw
        .cbSize = Len(tMIIOwnerDraw)
        .fMask = MIIM_FTYPE
    End With
    lRet = GetMenuItemInfo(m_hMenu, nID, False, tMIIOwnerDraw)
    If ((bOwnerDraw) And ((tMIIOwnerDraw.fType And MFT_OWNERDRAW) = 0)) Then
        '--Enable owner draw...
        tMIIOwnerDraw.fType = tMIIOwnerDraw.fType Or MFT_OWNERDRAW
    ElseIf ((Not bOwnerDraw) And (tMIIOwnerDraw.fType And MFT_OWNERDRAW)) Then
        '--Disable owner draw...
        tMIIOwnerDraw.fType = tMIIOwnerDraw.fType And (Not MFT_OWNERDRAW)
    End If
    lRet = SetMenuItemInfo(m_hMenu, nID, False, tMIIOwnerDraw)
End Function

Private Function setStateFlag(ByVal nID As Integer, ByVal lFlagOn As Long, ByVal lFlagOff As Long, ByVal bFlip As Boolean)
    Dim tMII As MENUITEMINFO, lRet As Long, lTmp As Long
    
    '--Toggle a state flag such as checked, selected, etc...
    If (bFlip) Then
        lTmp = lFlagOn
        lFlagOn = lFlagOff
        lFlagOff = lTmp
    End If
    
    With tMII
        .cbSize = Len(tMII)
        .fMask = MIIM_STATE
    End With
    lRet = GetMenuItemInfo(m_hMenu, nID, False, tMII)
    tMII.fState = tMII.fState And (Not lFlagOn) Or lFlagOff
    lRet = SetMenuItemInfo(m_hMenu, nID, False, tMII)
End Function

Public Function createMenu()
    Dim nCnt As Integer, i As Integer, lRet As Long, tMII As MENUITEMINFO, tMIIOwnerDraw As MENUITEMINFO, nW As Integer, nH As Integer
    
    Call deleteMenu
    Call mUtil.splitDWORD(GetMenuCheckMarkDimensions(), nW, nH)
    nCnt = UBound(m_szItemArr)
    
    ReDim m_hBmpArr(nCnt)
    ReDim Preserve m_oCheckmarkIconsArr(nCnt)
    For i = 0 To UBound(m_hBmpArr) Step 1
        m_hBmpArr(i) = 0
        If (Not m_oCheckmarkIconsArr(i) Is Nothing) Then
            If (m_oCheckmarkIconsArr(i).hasIcon()) Then
                m_hBmpArr(i) = m_oCheckmarkIconsArr(i).getHBMP(nW, nH, mUtil.convertColorStructure(vbMenuBar, [ColorRef To Color32]))
            End If
        End If
    Next i
    
    m_hMenu = CreatePopupMenu()
    For i = 0 To nCnt Step 1
        With tMII
            .cbSize = Len(tMII)
            .fMask = MIIM_ID
            .wID = (i + 1)
            
            If (m_szItemArr(i) <> "\-") Then
                .fMask = .fMask Or MIIM_STRING
                .dwTypeData = m_szItemArr(i)
                .cch = Len(m_szItemArr(i))
            Else
                .fMask = .fMask Or MIIM_FTYPE
                .fType = MFT_SEPARATOR
            End If
            
            If (m_hBmpArr(i)) Then
                .fMask = .fMask Or MIIM_CHECKMARKS
                .hbmpChecked = m_hBmpArr(i)
            End If
        End With
        lRet = InsertMenuItem(m_hMenu, i, True, tMII)
    Next i
End Function

Public Function showMenu(ByVal hWndButton As Long, ByVal eAlign As EAlignment) As Integer
    Dim hWndBtnParent As Long, lX As Long, lY As Long, lW As Long, lH As Long, lFlags As Long, lRet As Long
    
    hWndBtnParent = getTopLevelParent(hWndButton)
    Call mUtil.getWindowDimensions(hWndButton, lX, lY, lW, lH)
    lFlags = (TPM_LEFTBUTTON Or CLng(eAlign) Or TPM_TOPALIGN Or TPM_RETURNCMD Or TPM_VERPOSANIMATION)
    If (eAlign = ALIGN_CENTER) Then
        lX = lX + (lW \ 2)
    ElseIf (eAlign = ALIGN_RIGHT) Then
        lX = (lX + lW)
    End If
    Call mWndProc.subclass(hWndBtnParent, Me, "WndFunc")
    lRet = TrackPopupMenu(m_hMenu, lFlags, lX, (lY + lH), 0, hWndBtnParent, ByVal 0)
    Call mWndProc.unsubclass(hWndBtnParent)
    Call deleteMenu
    
    showMenu = CInt(lRet - 1)
End Function

Private Function deleteMenu()
    Dim i As Integer
    
    If (m_hMenu) Then
        Call DestroyMenu(m_hMenu)
        m_hMenu = 0
    End If
    
    If ((Not m_hBmpArr) <> -1) Then
        For i = 0 To UBound(m_hBmpArr) Step 1
            If (m_hBmpArr(i)) Then
                Call mUtil.DeleteObject(m_hBmpArr(i))
                m_hBmpArr(i) = 0
            End If
        Next i
        Erase m_hBmpArr
    End If
End Function

Public Function WndFunc(ByVal hWnd As Long, ByVal uiMsg As Long, ByVal wParam As Long, ByVal lParam As Long, ByRef vRet As Variant)
    Dim tMI As MEASUREITEMSTRUCT, tDI As DRAWITEMSTRUCT
    
    Select Case uiMsg
        Case WM_MEASUREITEM
            Call CopyMemory(tMI, ByVal lParam, Len(tMI))
            If (tMI.CtlType = ODT_MENU) Then
                RaiseEvent measureItem(tMI.itemWidth, tMI.itemHeight, tMI.itemData, tMI.itemID)
                Call CopyMemory(ByVal lParam, tMI, Len(tMI))
                vRet = 1
            End If
        
        Case WM_DRAWITEM
            Call CopyMemory(tDI, ByVal lParam, Len(tDI))
            If (tDI.CtlType = ODT_MENU) Then
                RaiseEvent drawItem(VarPtr(tDI))
                vRet = 1
            End If
    End Select
End Function

Public Property Get Tag() As String
    Tag = m_szTag
End Property
Public Property Let Tag(ByVal szVal As String)
    m_szTag = szVal
End Property

Public Property Get hMenu() As Long
    hMenu = m_hMenu
End Property

Public Property Get MenuItemCount() As Integer
    On Error GoTo EH
    
    MenuItemCount = UBound(m_szItemArr) + 1
    Exit Property
EH:
    MenuItemCount = 0
End Property
















