VERSION 5.00
Begin VB.UserControl X3Button 
   ClientHeight    =   435
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1245
   ScaleHeight     =   435
   ScaleWidth      =   1245
   ToolboxBitmap   =   "X3Button.ctx":0000
End
Attribute VB_Name = "X3Button"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'===============================================================================================================================================
' Xiphias3 Button
' October 24, 2009
'===============================================================================================================================================

Option Explicit

'===============================================================================================================================================
' D E C L A R A T I O N S
'===============================================================================================================================================

Private Declare Function GetClassName Lib "user32.dll" Alias "GetClassNameA" (ByVal hWnd As Long, ByVal lpClassName As String, ByVal nMaxCount As Long) As Long
Private Declare Function GetKeyState Lib "user32.dll" (ByVal nVirtKey As Long) As Integer
Private Const VK_LBUTTON As Long = &H1

Private Declare Function GdipLoadImageFromStream Lib "GdiPlus.dll" (ByVal mStream As Long, ByRef mImage As Long) As GpStatus

Private Declare Function SetWindowLong Lib "user32.dll" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function GetWindowLong Lib "user32.dll" Alias "GetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long) As Long
Private Const GWL_STYLE  As Long = -16
Private Const WS_TABSTOP As Long = &H10000

Public Enum EMouseEventType
    MET_MOUSEDOWN
    MET_MOUSEMOVE
    MET_MOUSEUP
End Enum

Public Enum EKeyEventType
    KET_UP
    KET_PRESS
    KET_DOWN
End Enum

Public Enum EDrawEventType
    DET_BACKGRND
    DET_BUTTON
    DET_DROPLINE
    DET_ICON
    DET_TEXT
    DET_REFRESH
End Enum

Public Event click(ByRef sX As Single, ByRef sY As Single)
Public Event dblClick(ByRef sX As Single, ByRef sY As Single)
Public Event mouseEvent(ByRef nButton As Integer, ByRef nShift As Integer, ByRef sX As Single, ByRef sY As Single, ByVal eMET As EMouseEventType)
Public Event focusChanged(ByRef bGotFocus As Boolean)
Public Event keyEvent(ByRef eKET As EKeyEventType, ByRef nKey As Integer, ByRef nShift As Integer)
Public Event drawEvent(ByVal eDE As EDrawEventType, ByVal hGraphics As Long, ByRef vData As Variant, ByRef bCancel As Boolean)

Public Enum EBackgroundMode
    [Fixed Color]
    [Parent BackColor]
    [Parent Image]
End Enum

Public Enum EButtonStyle
    AERO1
    AERO2
    AERO3
    AERO4
    BLUE
    BLUETASKBAND
    BLUETOOLBAR
    COOLER
    COUGHDROP
    GOLD
    GUCCI
    MACOS
    MACTOOLBAR1
    MACTOOLBAR2
    OLIVE
    PERL
    PLEX
    PURPLEISH
    ROYALBLUE
    ROYALWHITE
    SILVER
    TOOLBAR
    YELLOW
    OPERA
    OFFICE
    NONE
End Enum

Public Enum EIconPos
    IP_LEFT
    IP_TOP
    IP_RIGHT
    IP_BOTTOM
    IP_CENTER
End Enum

Public Enum EArrowDirection
    AD_UP
    AD_DOWN
    AD_LEFT
    AD_RIGHT
End Enum

Private Type State
    sW            As Single
    sH            As Single
    eBtnState     As EPushButtonState
End Type

Public Enum EHAlignment
    HLeft = &H0
    HCenter = &H1
    HRight = &H2
End Enum

Public Enum EVAlignment
    VTop = &H0
    VCenter = &H1
    VBottom = &H2
End Enum

'===============================================================================================================================================
' G L O B A L     V A R I A B L E S
'===============================================================================================================================================

Private m_hGDIPToken           As Long
Private m_bBtnOpacity          As Byte
Private m_bTxtOpacity          As Byte
Private m_bIconOpacity         As Byte
Private m_eBKMode              As EBackgroundMode
Private m_eBtnStyle            As EButtonStyle
Private m_hImgBtn              As Long
Private m_eState               As EPushButtonState
Private m_bHasFocus            As Boolean
Private m_szCaption            As String
Private m_oTxtPrinter          As X3TextPrinter
Private m_eHTxtAlign           As EHAlignment
Private m_eVTxtAlign           As EVAlignment
Private m_oBtnIcon             As X3BIcon
Private m_eIconPos             As EIconPos
Private m_nIconPosArr(3)       As Integer
Private m_bAutoSizeIcon        As Boolean
Private m_nPressOffsetArr(1)   As Integer
Private m_nCaptionOffsetArr(1) As Integer
Private m_oTxtCol              As OLE_COLOR
Private m_bDropDownStyle       As Boolean
Private m_bToggleStyle         As Boolean
Private m_eArrowDir            As EArrowDirection
Private m_bToggleValue         As Boolean
Private m_tPrevState           As State
Private m_bTabStop             As Boolean
Private m_bFormattingArr(4, 3) As Boolean
Private m_bDoubleBuffer        As Boolean
Private m_oRTFPrinter          As X3RTFPrinter
Private m_bRTFEnabled          As Boolean
Private m_bBeepOnDisabled      As Boolean
Private m_vShadowCol           As Variant
Private m_nShadowOffArr(1)     As Integer
Private m_vTxtOutlineCol       As Variant
Private m_bOutlineOpacity      As Byte
Private m_nOutlineWid          As Integer
Private m_oBackCol             As OLE_COLOR
Private m_lDropDownWid         As Long
Private m_bBusy                As Boolean

'===============================================================================================================================================
' I N I T I A L I Z E    A N D    T E R M I N A T E
'===============================================================================================================================================

Private Sub UserControl_Initialize()
    Dim oFnt As StdFont
        
    Call mMain.Main
    
    Set m_oTxtPrinter = New X3TextPrinter
    Set m_oRTFPrinter = New X3RTFPrinter
    
    Call m_oTxtPrinter.setText("-Xiphias3-")
    m_oRTFPrinter.Text = "-Xiphias3-"
    
    Set m_oBtnIcon = New X3BIcon
    
    Set oFnt = New StdFont
    oFnt.Name = "Arial"
    oFnt.Size = 14
    Set UserControl.Font = oFnt
    Call Randomize(Timer())
    
    With m_tPrevState
        .eBtnState = -1
        .sH = -1
        .sW = -1
    End With
    
    m_eBKMode = [Parent BackColor]
    m_eBtnStyle = AERO1
    m_eState = PBS_NORMAL
    m_szCaption = "-Xiphias3-"
    m_eHTxtAlign = HCenter
    m_eVTxtAlign = VCenter
    m_eIconPos = IP_LEFT
    m_bAutoSizeIcon = True
    m_nPressOffsetArr(0) = 1
    m_nPressOffsetArr(1) = 1
    m_nCaptionOffsetArr(0) = 0
    m_nCaptionOffsetArr(1) = 0
    m_bBtnOpacity = 255
    m_bTxtOpacity = 255
    m_bIconOpacity = 255
    m_oTxtCol = vbBlack
    m_bDropDownStyle = False
    m_bToggleStyle = False
    m_eArrowDir = AD_DOWN
    m_bToggleStyle = False
    m_bDoubleBuffer = False
    m_bRTFEnabled = False
    m_bBeepOnDisabled = False
    m_oBackCol = vbWhite
    
    m_vShadowCol = Empty
    m_nShadowOffArr(0) = 2
    m_nShadowOffArr(1) = 2
    
    m_vTxtOutlineCol = Empty
    m_bOutlineOpacity = 195
    m_nOutlineWid = 4
    
    m_lDropDownWid = 15
    
    m_bBusy = False
End Sub

Private Sub UserControl_Terminate()
    Call mUtil.deleteImage(m_hImgBtn)
    Set m_oRTFPrinter = Nothing
    Call m_oTxtPrinter.dispose
    Call m_oBtnIcon.dispose
End Sub

'===============================================================================================================================================
' E V E N T S
'===============================================================================================================================================

Private Sub UserControl_Paint()
    Call redrawButton(False)
End Sub

Private Sub UserControl_KeyDown(KeyCode As Integer, Shift As Integer)
    If (m_eState = PBS_DISABLED) Then Exit Sub
    RaiseEvent keyEvent(KET_DOWN, KeyCode, Shift)
End Sub

Private Sub UserControl_KeyPress(KeyAscii As Integer)
    If (m_eState = PBS_DISABLED) Then Exit Sub
    RaiseEvent keyEvent(KET_PRESS, KeyAscii, 0)
    If (KeyAscii = vbKeySpace) Then Call UserControl_Click
End Sub

Private Sub UserControl_KeyUp(KeyCode As Integer, Shift As Integer)
    If (m_eState = PBS_DISABLED) Then Exit Sub
    RaiseEvent keyEvent(KET_UP, KeyCode, Shift)
End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    If (m_eState = PBS_DISABLED) Then
        If (m_bBeepOnDisabled) Then Call Beep
        Exit Sub
    End If
    
    If ((Button And vbRightButton) = vbRightButton) Then Exit Sub
    
    If (Not m_bToggleStyle) Then
        m_eState = PBS_PRESSED
    Else
        If (m_eState <> PBS_PRESSED) Then
            m_eState = PBS_PRESSED
        Else
            m_eState = PBS_NORMAL
        End If
    End If
    
    Call redrawButton
    RaiseEvent mouseEvent(Button, Shift, x, y, MET_MOUSEDOWN)
End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    If (m_eState = PBS_DISABLED) Then Exit Sub
    If ((Button And vbRightButton) = vbRightButton) Then Exit Sub
    
    If (Not mUtil.mouseOverControl(UserControl.hWnd)) Then
        Call mUtil.ReleaseCapture
    End If
    
    If (Not m_bToggleStyle) Then
        If (mUtil.mouseOverControl(UserControl.hWnd)) Then
            m_eState = PBS_HOT
        ElseIf (m_bHasFocus) Then
            m_eState = PBS_FOCUS
        Else
            m_eState = PBS_NORMAL
        End If
    Else
        '...
    End If
    
    Call redrawButton
    RaiseEvent mouseEvent(Button, Shift, x, y, MET_MOUSEUP)
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
    Dim bMouseOver As Boolean, bCapturedMouse As Boolean, bLMBDown As Boolean
    
    If (m_eState = PBS_DISABLED) Then Exit Sub
    If ((Button And vbRightButton) = vbRightButton) Then Exit Sub
    
    bMouseOver = (mUtil.mouseOverControl(UserControl.hWnd) = True)
    bCapturedMouse = (mUtil.GetCapture() = UserControl.hWnd)
    bLMBDown = ((Button And vbLeftButton) = vbLeftButton)
    
    If ((bMouseOver) And (Not bCapturedMouse)) Then
        Call mUtil.SetCapture(UserControl.hWnd)
        If (m_eState <> PBS_PRESSED) Then m_eState = PBS_HOT
    ElseIf ((Not bMouseOver) And (bCapturedMouse) And (Not bLMBDown)) Then
        Call mUtil.ReleaseCapture
        If (Not m_bToggleStyle) Then
            If (m_bHasFocus) Then m_eState = PBS_FOCUS Else m_eState = PBS_NORMAL
        Else
            If (m_eState <> PBS_PRESSED) Then
                If (m_bHasFocus) Then m_eState = PBS_FOCUS Else m_eState = PBS_NORMAL
            End If
        End If
    ElseIf ((Not bMouseOver) And (bCapturedMouse) And (bLMBDown)) Then
        If (Not m_bToggleStyle) Then
            m_eState = PBS_NORMAL
        End If
    ElseIf ((bMouseOver) And (bCapturedMouse) And (bLMBDown)) Then
        m_eState = PBS_PRESSED
    End If
    
    Call redrawButton
    RaiseEvent mouseEvent(Button, Shift, x, y, MET_MOUSEMOVE)
End Sub

Private Sub UserControl_Click()
    Dim lX As Long, lY As Long
    
    If (m_eState = PBS_DISABLED) Then Exit Sub
    
    Call redrawButton
    Call mUtil.getRelativeCursorPosition(lX, lY, UserControl.hWnd)
    RaiseEvent click(CSng(lX), CSng(lY))
End Sub

Private Sub UserControl_DblClick()
    Dim lX As Long, lY As Long
    
    If (m_eState = PBS_DISABLED) Then
        Exit Sub
    Else
        Call mUtil.getRelativeCursorPosition(lX, lY, UserControl.hWnd)
        RaiseEvent dblClick(CSng(lX), CSng(lY))
    End If
End Sub

Private Sub UserControl_EnterFocus()
    If (m_eState = PBS_DISABLED) Then Exit Sub
    
    m_bHasFocus = True
    If (Not m_bToggleStyle) Then
        If (Not mUtil.mouseOverControl(UserControl.hWnd)) Then
            m_eState = PBS_FOCUS
        End If
    Else
        If (m_eState <> PBS_PRESSED) Then
            m_eState = PBS_FOCUS
            If (mUtil.mouseOverControl(UserControl.hWnd)) Then
                m_eState = PBS_HOT
            End If
        End If
    End If
    RaiseEvent focusChanged(True)
    Call redrawButton(False)
End Sub

Private Sub UserControl_ExitFocus()
    If (m_eState = PBS_DISABLED) Then Exit Sub
    
    m_bHasFocus = False
    If (Not m_bToggleStyle) Then
        If (Not mUtil.mouseOverControl(UserControl.hWnd)) Then
            m_eState = PBS_NORMAL
        End If
    Else
        If (m_eState <> PBS_PRESSED) Then
            m_eState = PBS_NORMAL
            If (mUtil.mouseOverControl(UserControl.hWnd)) Then
                m_eState = PBS_HOT
            End If
        End If
    End If
    RaiseEvent focusChanged(False)
    Call redrawButton(False)
End Sub

Private Sub UserControl_Resize()
    Call resetIconProperties
    Call redrawButton(False)
End Sub

'===============================================================================================================================================
' P R O P E R T I E S
'===============================================================================================================================================

Public Property Get ButtonOpacity() As Byte
    ButtonOpacity = m_bBtnOpacity
End Property
Public Property Let ButtonOpacity(ByRef bVal As Byte)
    m_bBtnOpacity = bVal
    Call redrawButton(False)
End Property

Public Property Get BackColor() As OLE_COLOR
    BackColor = m_oBackCol
End Property
Public Property Let BackColor(ByVal oNewCol As OLE_COLOR)
    m_oBackCol = oNewCol
    Call redrawButton(False)
End Property

Public Property Get CaptionOpacity() As Byte
    CaptionOpacity = m_bTxtOpacity
End Property
Public Property Let CaptionOpacity(ByRef bVal As Byte)
    m_bTxtOpacity = bVal
    Call redrawButton(False)
End Property

Public Property Get IconOpacity() As Byte
    IconOpacity = m_bIconOpacity
End Property
Public Property Let IconOpacity(ByRef bVal As Byte)
    m_bIconOpacity = bVal
    Call redrawButton(False)
End Property

Public Property Get BackgroundMode() As EBackgroundMode
    BackgroundMode = m_eBKMode
End Property
Public Property Let BackgroundMode(ByRef eMode As EBackgroundMode)
    m_eBKMode = eMode
    Call redrawButton(False)
End Property

Public Property Get ButtonStyle() As EButtonStyle
    ButtonStyle = m_eBtnStyle
End Property
Public Property Let ButtonStyle(ByRef eStyle As EButtonStyle)
    m_eBtnStyle = eStyle
    Call loadButton
    Call redrawButton(False)
End Property

Public Property Get Caption() As String
    Caption = m_szCaption
End Property
Public Property Let Caption(ByRef szCaption As String)
    m_szCaption = szCaption
    Call m_oTxtPrinter.setText(m_szCaption)
    m_oRTFPrinter.Text = m_szCaption
    Call redrawButton(False)
End Property

Public Property Get CaptionHAlignment() As EHAlignment
    CaptionHAlignment = m_eHTxtAlign
End Property
Public Property Let CaptionHAlignment(ByVal eAlign As EHAlignment)
    m_eHTxtAlign = eAlign
    Call redrawButton(False)
End Property

Public Property Get CaptionVAlignment() As EVAlignment
    CaptionVAlignment = m_eVTxtAlign
End Property
Public Property Let CaptionVAlignment(ByVal eAlign As EVAlignment)
    m_eVTxtAlign = eAlign
    Call redrawButton(False)
End Property

Public Property Get CaptionShadowColor() As String
Attribute CaptionShadowColor.VB_Description = "&HAARRGGBB"
    If (IsEmpty(m_vShadowCol)) Then
        CaptionShadowColor = "NONE"
    Else
        CaptionShadowColor = "&H" + Right("00000000" + Hex(CLng(m_vShadowCol)), 8)
    End If
    Call redrawButton(False)
End Property
Public Property Let CaptionShadowColor(ByVal szVal As String)
    On Error GoTo EH
    
    szVal = Trim(szVal)
    If (szVal = "") Then m_vShadowCol = Empty Else m_vShadowCol = CLng(szVal)
    Call redrawButton(False)
    Exit Property
EH:
    Call Err.Clear
End Property

Public Property Get CaptionShadowOffset() As String
    CaptionShadowOffset = m_nShadowOffArr(0) & "," & m_nShadowOffArr(1)
End Property
Public Property Let CaptionShadowOffset(ByVal szOffset As String)
    On Error GoTo EH
    Dim szParamArr() As String
    
    szParamArr = Split(szOffset, ",")
    If (UBound(szParamArr) = 1) Then
        m_nShadowOffArr(0) = CInt(szParamArr(0))
        m_nShadowOffArr(1) = CInt(szParamArr(1))
        Call redrawButton(False)
    End If
EH:
End Property

Public Property Get CaptionOutlineColor() As String
Attribute CaptionOutlineColor.VB_Description = "&HAARRGGBB"
    If (IsEmpty(m_vTxtOutlineCol)) Then
        CaptionOutlineColor = "NONE"
    Else
        CaptionOutlineColor = "&H" + Right("00000000" + Hex(CLng(m_vTxtOutlineCol)), 8)
    End If
End Property
Public Property Let CaptionOutlineColor(ByVal szVal As String)
    szVal = Trim(szVal)
    If (szVal = "") Then
        m_vTxtOutlineCol = Empty
    Else
        m_vTxtOutlineCol = CLng(szVal)
    End If
    Call redrawButton(False)
End Property

Public Property Get CaptionOutlineWidth() As Integer
    CaptionOutlineWidth = m_nOutlineWid
End Property
Public Property Let CaptionOutlineWidth(ByVal nWid As Integer)
    If (nWid >= 0) Then
        m_nOutlineWid = nWid
        Call redrawButton(False)
    End If
End Property

Public Property Get CaptionOutlineOpacity() As Byte
    CaptionOutlineOpacity = m_bOutlineOpacity
End Property
Public Property Let CaptionOutlineOpacity(ByVal bOpacity As Byte)
    m_bOutlineOpacity = bOpacity
    Call redrawButton(False)
End Property

Public Property Get Icon() As String
    Icon = m_oBtnIcon.IconFileName
End Property
Public Property Let Icon(ByRef szPath As String)
    Call resetIconProperties
    Call m_oBtnIcon.loadIcon(szPath)
    Call redrawButton(False)
End Property

Public Property Get IconXYWH() As String
    If (Not m_oBtnIcon.hasIcon()) Then IconXYWH = "": Exit Property
    IconXYWH = m_nIconPosArr(0) & "," & m_nIconPosArr(1) & "," & m_nIconPosArr(2) & "," & m_nIconPosArr(3)
End Property
Public Property Let IconXYWH(ByRef szProp As String)
    On Error GoTo EH
    Dim szParamArr() As String, i As Integer, nPosArr(3) As Integer
    
    szParamArr = Split(szProp, ",")
    If (UBound(szParamArr) > 3) Then Call Err.Raise(vbObjectError + 1)
    For i = 0 To 3 Step 1
        nPosArr(i) = CInt(szParamArr(i))
    Next i
    
    m_nIconPosArr(0) = nPosArr(0)
    m_nIconPosArr(1) = nPosArr(1)
    m_nIconPosArr(2) = nPosArr(2)
    m_nIconPosArr(3) = nPosArr(3)
    
    Call redrawButton(False)
    Exit Property
    
EH: Call Err.Clear
End Property

Public Property Get IconAutoSize() As Boolean
Attribute IconAutoSize.VB_Description = "Make the icon fit inside the button"
    IconAutoSize = m_bAutoSizeIcon
End Property
Public Property Let IconAutoSize(ByVal bAutoSize As Boolean)
    m_bAutoSizeIcon = bAutoSize
    Call resetIconProperties
    Call redrawButton(False)
End Property

Public Property Get IconPosition() As EIconPos
    IconPosition = m_eIconPos
End Property
Public Property Let IconPosition(ByVal ePos As EIconPos)
    m_eIconPos = ePos
    Call resetIconProperties
    Call redrawButton(False)
End Property

Public Property Get PressOffset() As String
    PressOffset = m_nPressOffsetArr(0) & "," & m_nPressOffsetArr(1)
End Property
Public Property Let PressOffset(ByVal szOffset As String)
    On Error GoTo EH
    Dim szParamArr() As String, nOffsetArr(1) As Integer
    
    szParamArr = Split(szOffset, ",")
    nOffsetArr(0) = CInt(szParamArr(0))
    nOffsetArr(1) = CInt(szParamArr(1))
    
    m_nPressOffsetArr(0) = nOffsetArr(0)
    m_nPressOffsetArr(1) = nOffsetArr(1)

EH: Call Err.Clear
End Property

Public Property Get CaptionFont() As StdFont
    Set CaptionFont = UserControl.Font
End Property
Public Property Set CaptionFont(ByVal oFnt As StdFont)
    Dim oTP As X3TextPrinter
    
    Set oTP = New X3TextPrinter
    If (oTP.setFontFromStdFont(oFnt)) Then
        Set UserControl.Font = oFnt
        Call redrawButton(False)
    Else
        Call MsgBox("Invalid font!" + vbCrLf + "Font MUST be True-Type.", vbOKOnly Or vbExclamation, "Text Font")
    End If
    Set oTP = Nothing
End Property

Public Property Get CaptionColor() As OLE_COLOR
Attribute CaptionColor.VB_Description = "&H00BBGGRR"
    CaptionColor = m_oTxtCol
End Property
Public Property Let CaptionColor(ByVal oCol As OLE_COLOR)
    m_oTxtCol = oCol
    Call redrawButton(False)
End Property

Public Property Get CaptionOffset() As String
    CaptionOffset = m_nCaptionOffsetArr(0) & "," & m_nCaptionOffsetArr(1)
End Property
Public Property Let CaptionOffset(ByVal szVal As String)
    On Error GoTo EH
    Dim szParamArr() As String, i As Integer, nValArr() As Integer
    
    szParamArr = Split(szVal, ",")
    If (UBound(szParamArr) = 1) Then
        ReDim nValArr(1)
        For i = 0 To 1 Step 1
            nValArr(i) = CInt(szParamArr(i))
        Next i
        m_nCaptionOffsetArr(0) = nValArr(0)
        m_nCaptionOffsetArr(1) = nValArr(1)
        Call redrawButton(False)
    End If
    Exit Property
    
EH:
    Call Err.Clear
End Property

Public Property Get DropDownStyle() As Boolean
    DropDownStyle = m_bDropDownStyle
End Property
Public Property Let DropDownStyle(ByVal bVal As Boolean)
    m_bDropDownStyle = bVal
    Call redrawButton(False)
End Property

Public Property Get DropdownArrowDir() As EArrowDirection
    DropdownArrowDir = m_eArrowDir
End Property
Public Property Let DropdownArrowDir(ByVal eDir As EArrowDirection)
    m_eArrowDir = eDir
    Call redrawButton(False)
End Property

Public Property Get DropDownWidth() As Long
    DropDownWidth = m_lDropDownWid
End Property
Public Property Let DropDownWidth(ByVal lWid As Long)
    m_lDropDownWid = lWid
    Call redrawButton(False)
End Property

Public Property Get ToggleStyle() As Boolean
    ToggleStyle = m_bToggleStyle
End Property
Public Property Let ToggleStyle(ByVal bVal As Boolean)
    m_bToggleStyle = bVal
    If (Not m_bToggleStyle) Then
        m_bToggleValue = False
        m_eState = PBS_NORMAL
    End If
    Call redrawButton(False)
End Property

Public Property Get ToggleValue() As Boolean
    ToggleValue = m_bToggleValue
End Property
Public Property Let ToggleValue(ByVal bVal As Boolean)
    If (m_bToggleStyle) Then
        m_bToggleValue = bVal
        If (m_bToggleValue) Then
            If (m_eState <> PBS_PRESSED) Then m_eState = PBS_PRESSED Else m_eState = PBS_NORMAL
        Else
            m_eState = PBS_NORMAL
        End If
        Call redrawButton(False)
    End If
End Property

Public Property Get hWnd() As Long
    hWnd = UserControl.hWnd
End Property

Public Property Get hdc() As Long
    hdc = UserControl.hdc
End Property

Public Property Get Enabled() As Boolean
    Enabled = (m_eState <> PBS_DISABLED)
End Property
Public Property Let Enabled(ByVal bVal As Boolean)
    If (bVal) Then m_eState = PBS_NORMAL Else m_eState = PBS_DISABLED
    If (m_eState = PBS_DISABLED) Then TabStop = False
End Property

Public Property Get TabStop() As Boolean
    TabStop = m_bTabStop
End Property
Public Property Let TabStop(bVal As Boolean)
    Dim lStyle As Long
    
    lStyle = GetWindowLong(UserControl.hWnd, GWL_STYLE)
    If ((bVal) And ((lStyle And WS_TABSTOP) = 0)) Then
        lStyle = lStyle Or WS_TABSTOP
        Call SetWindowLong(UserControl.hWnd, GWL_STYLE, lStyle)
    ElseIf ((Not bVal) And ((lStyle And WS_TABSTOP) = WS_TABSTOP)) Then
        lStyle = lStyle And Not WS_TABSTOP
        Call SetWindowLong(UserControl.hWnd, GWL_STYLE, lStyle)
    End If
End Property

Public Property Get MousePointer() As MousePointerConstants
    MousePointer = UserControl.MousePointer
End Property
Public Property Let MousePointer(eVal As MousePointerConstants)
    UserControl.MousePointer = eVal
End Property

Public Property Get MouseIcon() As StdPicture
    Set MouseIcon = UserControl.MouseIcon
End Property
Public Property Set MouseIcon(pic As StdPicture)
    Set UserControl.MouseIcon = pic
End Property

Public Property Get CaptionProperties() As String
Attribute CaptionProperties.VB_Description = "Caption formatting props for each state. ""p1,p2,p3,p4,p5"". p = BIUS, p1-p5->Normal,Hot,Pressed,Disabled,Focus"
    Dim i As Integer, szProp As String
    
    For i = 0 To 4 Step 1
        If (i > 0) Then szProp = szProp + ","
        If (m_bFormattingArr(i, 0)) Then szProp = szProp + "B"
        If (m_bFormattingArr(i, 1)) Then szProp = szProp + "I"
        If (m_bFormattingArr(i, 2)) Then szProp = szProp + "U"
        If (m_bFormattingArr(i, 3)) Then szProp = szProp + "S"
    Next i
    CaptionProperties = szProp
End Property
Public Property Let CaptionProperties(ByVal szVal As String)
    On Error GoTo EH
    Dim szPropArr() As String, i As Integer, nAsc As Integer
    
    If (szVal = "") Then
        For i = 0 To 4 Step 1
            m_bFormattingArr(i, 0) = False
            m_bFormattingArr(i, 1) = False
            m_bFormattingArr(i, 2) = False
            m_bFormattingArr(i, 3) = False
        Next i
        Exit Property
    End If
    
    szVal = UCase(szVal)
    For i = 1 To Len(szVal) Step 1
        nAsc = Asc(Mid(szVal, i, 1))
        If ((nAsc <> vbKeyB) And (nAsc <> vbKeyI) And (nAsc <> vbKeyU) And (nAsc <> vbKeyS) And (Mid(szVal, i, 1) <> ",")) Then
            Call Err.Raise(vbObjectError + 1, , "Invalid latter")
        End If
    Next i
    szPropArr = Split(szVal, ",")
    If (UBound(szPropArr) <> 4) Then Call Err.Raise(vbObjectError + 1, , "Invalid param count")
    For i = 0 To 4 Step 1
        m_bFormattingArr(i, 0) = (InStr(1, szPropArr(i), "B") <> 0)
        m_bFormattingArr(i, 1) = (InStr(1, szPropArr(i), "I") <> 0)
        m_bFormattingArr(i, 2) = (InStr(1, szPropArr(i), "U") <> 0)
        m_bFormattingArr(i, 3) = (InStr(1, szPropArr(i), "S") <> 0)
    Next i
    Call redrawButton(False)
    Exit Property
    
EH: Call Err.Clear
End Property

Public Property Get DoubleBuffer() As Boolean
    DoubleBuffer = m_bDoubleBuffer
End Property
Public Property Let DoubleBuffer(ByVal bVal As Boolean)
    m_bDoubleBuffer = bVal
    Call redrawButton(False)
End Property

Public Property Get RTFEnabled() As Boolean
    RTFEnabled = m_bRTFEnabled
End Property
Public Property Let RTFEnabled(ByVal bVal As Boolean)
    m_bRTFEnabled = bVal
    Call redrawButton(False)
End Property

Public Property Get BeepOnDisabledClick() As Boolean
    BeepOnDisabledClick = m_bBeepOnDisabled
End Property
Public Property Let BeepOnDisabledClick(ByVal bVal As Boolean)
    m_bBeepOnDisabled = bVal
End Property

Public Property Get AutoSizeUsingIcon() As Boolean
Attribute AutoSizeUsingIcon.VB_Description = "Size the control to that of theicon dimensions."
    AutoSizeUsingIcon = False
    If (m_oBtnIcon.hasIcon()) Then
        With m_oBtnIcon
            If ((UserControl.Width = (.Width * Screen.TwipsPerPixelX)) And (UserControl.Height = (.Height * Screen.TwipsPerPixelY))) Then
                AutoSizeUsingIcon = True
            End If
        End With
    End If
End Property
Public Property Let AutoSizeUsingIcon(ByVal bVal As Boolean)
    If (Not m_oBtnIcon.hasIcon()) Then Exit Property
    If (bVal = False) Then Exit Property
    UserControl.Width = (m_oBtnIcon.Width * Screen.TwipsPerPixelX)
    UserControl.Height = (m_oBtnIcon.Height * Screen.TwipsPerPixelY)
    Call redrawButton(False)
End Property

Public Property Get ButtonImage() As Long
    ButtonImage = m_hImgBtn
End Property
Public Property Let ButtonImage(ByVal hImgNew As Long)
    m_hImgBtn = hImgNew
    Call redrawButton(False)
End Property

Public Property Get RTFPrinter()
    Set RTFPrinter = m_oRTFPrinter
End Property

Public Property Get TextPrinter()
    Set TextPrinter = m_oTxtPrinter
End Property

Public Property Get IconImage()
    Set IconImage = m_oBtnIcon
End Property

'===============================================================================================================================================
' P R O P E R T Y     P E R S I S T E N C E
'===============================================================================================================================================

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Dim bPNGDataArr() As Byte
    
    With PropBag
        Call .WriteProperty("ButtonState", m_eState, EPushButtonState.PBS_NORMAL)
        Call .WriteProperty("BackgroundMode", m_eBKMode, EBackgroundMode.[Parent BackColor])
        Call .WriteProperty("ButtonStyle", m_eBtnStyle, EButtonStyle.AERO1)
        Call .WriteProperty("Caption", m_szCaption, "Xiphias3")
        Call .WriteProperty("CaptionHAlignment", m_eHTxtAlign, EHAlignment.HCenter)
        Call .WriteProperty("CaptionVAlignment", m_eVTxtAlign, EVAlignment.VCenter)
        Call .WriteProperty("Icon", m_oBtnIcon.IconFileName, "")
        Call .WriteProperty("IconPosition", m_eIconPos, EIconPos.IP_LEFT)
        Call .WriteProperty("IconXYWH", IconXYWH, "0,0,0,0")
        Call .WriteProperty("IconAutoSize", IconAutoSize, True)
        Call .WriteProperty("PressOffset", PressOffset, "1,1")
        Call .WriteProperty("ButtonOpacity", ButtonOpacity, 255)
        Call .WriteProperty("CaptionOpacity", CaptionOpacity, 255)
        Call .WriteProperty("IconOpacity", IconOpacity, 255)
        Call .WriteProperty("CaptionFont", CaptionFont, Nothing)
        Call .WriteProperty("CaptionColor", m_oTxtCol, vbBlack)
        Call .WriteProperty("DropDownStyle", m_bDropDownStyle, False)
        Call .WriteProperty("ToggleStyle", m_bToggleStyle, False)
        Call .WriteProperty("DropdownArrowDir", m_eArrowDir, EArrowDirection.AD_DOWN)
        Call .WriteProperty("CaptionOffset", CaptionOffset, "0,0")
        Call .WriteProperty("ToggleValue", m_bToggleValue, False)
        Call .WriteProperty("TabStop", m_bTabStop, True)
        Call .WriteProperty("MousePointer", UserControl.MousePointer, MousePointerConstants.vbDefault)
        Call .WriteProperty("MouseIcon", UserControl.MouseIcon, Nothing)
        Call .WriteProperty("CaptionProperties", CaptionProperties, "")
        Call .WriteProperty("DoubleBuffer", m_bDoubleBuffer, False)
        Call .WriteProperty("RTFEnabled", m_bRTFEnabled, False)
        Call .WriteProperty("BeepOnDisabledClick", m_bBeepOnDisabled, False)
        Call .WriteProperty("RTFText", m_oRTFPrinter.getRTF(False), "")
        Call .WriteProperty("CaptionShadowColor", m_vShadowCol, Empty)
        Call .WriteProperty("CaptionShadowOffset", CaptionShadowOffset, "0,0")
        Call .WriteProperty("CaptionOutlineColor", m_vTxtOutlineCol, Empty)
        Call .WriteProperty("CaptionOutlineOpacity", m_bOutlineOpacity, 195)
        Call .WriteProperty("CaptionOutlineWidth", m_nOutlineWid, 4)
        Call .WriteProperty("BackColor", m_oBackCol, vbWhite)
        Call .WriteProperty("DropDownWidth", m_lDropDownWid, 15)
        
        If (m_oBtnIcon.hasIcon()) Then
            If (m_oBtnIcon.getIconAsPNGByteStream(bPNGDataArr)) Then
                Call .WriteProperty("IconPNGData", bPNGDataArr, Empty)
            End If
        Else
            Call .WriteProperty("IconPNGData", Empty)
        End If
    End With
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    Dim oDefaultFnt As StdFont, pStream As IStream, bDataArr() As Byte, vData As Variant
    
    Set oDefaultFnt = New StdFont
    oDefaultFnt.Name = "Arial"
    oDefaultFnt.Size = 10
    
    With PropBag
        m_eState = .ReadProperty("ButtonState", EPushButtonState.PBS_NORMAL)
        m_eBKMode = .ReadProperty("BackgroundMode", EBackgroundMode.[Parent BackColor])
        m_eBtnStyle = .ReadProperty("ButtonStyle", EButtonStyle.BLUE)
        m_szCaption = .ReadProperty("Caption", "Xiphias3")
        m_eHTxtAlign = .ReadProperty("CaptionHAlignment", EHAlignment.HCenter)
        m_eVTxtAlign = .ReadProperty("CaptionVAlignment", EVAlignment.VCenter)
        m_eBtnStyle = .ReadProperty("ButtonStyle", EButtonStyle.AERO1)
        m_eIconPos = .ReadProperty("IconPosition", EIconPos.IP_LEFT)
        m_bAutoSizeIcon = .ReadProperty("IconAutoSize", True)
        IconXYWH = .ReadProperty("IconXYWH", "")
        PressOffset = .ReadProperty("PressOffset", "1,1")
        m_bBtnOpacity = .ReadProperty("ButtonOpacity", 255)
        m_bTxtOpacity = .ReadProperty("CaptionOpacity", 255)
        m_bIconOpacity = .ReadProperty("IconOpacity", 255)
        m_oTxtCol = .ReadProperty("CaptionColor", vbBlack)
        m_bDropDownStyle = .ReadProperty("DropDownStyle", False)
        m_bToggleStyle = .ReadProperty("ToggleStyle", False)
        m_eArrowDir = .ReadProperty("DropdownArrowDir", EArrowDirection.AD_DOWN)
        CaptionOffset = .ReadProperty("CaptionOffset", "0,0")
        m_bToggleValue = .ReadProperty("ToggleValue", False)
        TabStop = .ReadProperty("TabStop", True)
        UserControl.MousePointer = .ReadProperty("MousePointer", MousePointerConstants.vbDefault)
        CaptionProperties = .ReadProperty("CaptionProperties", "")
        m_bDoubleBuffer = .ReadProperty("DoubleBuffer", False)
        m_bRTFEnabled = .ReadProperty("RTFEnabled", False)
        m_bBeepOnDisabled = .ReadProperty("BeepOnDisabledClick", False)
        m_vShadowCol = .ReadProperty("CaptionShadowColor", Empty)
        CaptionShadowOffset = .ReadProperty("CaptionShadowOffset", "0,0")
        m_vTxtOutlineCol = .ReadProperty("CaptionOutlineColor", Empty)
        m_bOutlineOpacity = .ReadProperty("CaptionOutlineOpacity", 195)
        m_nOutlineWid = .ReadProperty("CaptionOutlineWidth", 4)
        m_oBackCol = .ReadProperty("BackColor", vbWhite)
        m_lDropDownWid = .ReadProperty("DropDownWidth", 15)
        
        vData = .ReadProperty("IconPNGData", Empty)
        If (Not IsEmpty(vData)) Then
            bDataArr = vData
            If (UBound(bDataArr) > 0) Then
                Set pStream = mUtil.byteArray2Stream(bDataArr)
                If (Not pStream Is Nothing) Then Call m_oBtnIcon.loadIcon("stream://" & ObjPtr(pStream))
            End If
            Set pStream = Nothing
        End If
        
        Set UserControl.MouseIcon = .ReadProperty("MouseIcon", Nothing)
        Set UserControl.Font = .ReadProperty("CaptionFont", oDefaultFnt)
        Call m_oRTFPrinter.setRTF(False, CStr(.ReadProperty("RTFText", "")))
        Call loadButton
    End With
End Sub

'===============================================================================================================================================
' F U N C T I O N S
'===============================================================================================================================================

Public Function about()
Attribute about.VB_Description = "About X3Button"
Attribute about.VB_UserMemId = -552
    Call frmAbout.Show(vbModal)
End Function

Public Function inIDE() As Boolean
    On Error Resume Next
    
    Debug.Print (1 / 0)
    inIDE = (Err.Number <> 0)
    If (Err.Number <> 0) Then Call Err.Clear
End Function

Public Function isOCXCompiled() As Boolean
    Dim szBuff As String
    
    ' Uncompiled: ThunderUserControlDC
    ' Compiled:   ThunderRT6UserControlDC
    szBuff = String(32, vbNullChar)
    Call GetClassName(UserControl.hWnd, szBuff, Len(szBuff))
    szBuff = Replace(szBuff, vbNullChar, "")
    isOCXCompiled = (InStr(1, szBuff, "ThunderRT6", vbTextCompare) <> 0)
End Function

Public Function loadButton()
    Dim szPath As String, szStyleName As String, bDataArr() As Byte, pStream As IStream, oTmpIcon As X3BIcon, eRet As GpStatus
    
    szStyleName = CStr(Choose(CInt(m_eBtnStyle) + 1, "AERO1", "AERO2", "AERO3", "AERO4", "BLUE", "BLUETASKBAND", "BLUETOOLBAR", _
                                                     "COOLER", "COUGHDROP", "GOLD", "GUCCI", "MACOS", "MACTOOLBAR1", "MACTOOLBAR2", _
                                                     "OLIVE", "PERL", "PLEX", "PURPLEISH", "ROYALBLUE", "ROYALWHITE", "SILVER", _
                                                     "TOOLBAR", "YELLOW", "OPERA", "OFFICE", ""))
    
    Call mUtil.deleteImage(m_hImgBtn)
    If ((inIDE() And (isOCXCompiled() = False))) Then
        szPath = "C:\Program Files\Microsoft Visual Studio\Common\MSDev98\Bin\Button PNGs\" + szStyleName + ".png"
        Call mUtil.loadImage(StrConv(szPath, vbUnicode), m_hImgBtn, (Not inIDE()))
    Else
        If (mUtil.resource2ByteArray(szStyleName, "BUTTONS", bDataArr())) Then
            Set pStream = mUtil.byteArray2Stream(bDataArr)
            If (Not pStream Is Nothing) Then
                eRet = GdipLoadImageFromStream(ObjPtr(pStream), m_hImgBtn)
            End If
            Erase bDataArr
            If (m_hImgBtn = 0) Then Call MsgBox("Unable to load " + szStyleName)
        End If
    End If
End Function

Public Function redrawButton(Optional ByRef bCheckForChange As Boolean = True)
    On Error GoTo EH
    Dim hGraphics As Long, lW As Long, lH As Long, lCol As Long, oParent As Object, bRet As Boolean, rcTxtArea As RECTL, nXOff As Integer, _
        nYOff As Integer, oFnt As StdFont, lLineCol As Long, lLineX As Long, i As Integer, bArrowClick As Boolean, hDCCtl As Long, _
        vData As Variant, bCancel As Boolean, lLineY As Long, lLineH As Long, lArrowCol As Long, vArr As Variant
    
    ' Possible "Client site not available error"
    lW = (UserControl.Width \ Screen.TwipsPerPixelX)
    lH = (UserControl.Height \ Screen.TwipsPerPixelY)
    Set oParent = UserControl.Parent
    lLineX = (lW - m_lDropDownWid)
        
    If (bCheckForChange) Then
        If ((UserControl.Width = m_tPrevState.sW) And (UserControl.Height = m_tPrevState.sH) And (m_eState = m_tPrevState.eBtnState)) Then
            Exit Function
        End If
    End If
    
    If (m_eState = PBS_PRESSED) Then
        nXOff = m_nPressOffsetArr(0)
        nYOff = m_nPressOffsetArr(1)
    End If
    If (Not UserControl.AutoRedraw) Then UserControl.AutoRedraw = True
    
    bCancel = False
    RaiseEvent drawEvent(DET_BACKGRND, hGraphics, Empty, bCancel)
    If (Not bCancel) Then
        Select Case m_eBKMode
            Case EBackgroundMode.[Fixed Color]
                Call mUtil.fillRectGDI(UserControl.hdc, m_oBackCol, 0, 0, lW, lH)
    
            Case EBackgroundMode.[Parent BackColor]
                Call mUtil.fillRectGDI(UserControl.hdc, oParent.BackColor, 0, 0, lW, lH)
    
            Case EBackgroundMode.[Parent Image]
                Call mUtil.blitParentBackground(UserControl.hWnd, UserControl.hdc, oParent.hdc)
        End Select
    End If
    
    hGraphics = mUtil.getGraphicsContext(UserControl.hdc)
    Call mUtil.setAAGraphicsSmoothingMode(hGraphics)

    bCancel = False
    RaiseEvent drawEvent(DET_BUTTON, hGraphics, m_hImgBtn, bCancel)
    If (Not bCancel) Then
        If (m_eBtnStyle <> NONE) Then
            If (m_hImgBtn = 0) Then Call loadButton
            Call mUtil.drawXPThemeButtonL(hGraphics, m_hImgBtn, m_eState, 0, 0, lW, lH, m_bBtnOpacity, 1, 1, 1, 1)
        End If
    End If

    If (m_bDropDownStyle) Then
        bArrowClick = ((isArrowClick(lLineX)) And (m_bHasFocus))
        If (bArrowClick) Then nXOff = 0: nYOff = 0
        If (m_hImgBtn) Then
            Call mUtil.getBorderColor(m_hImgBtn, lLineCol)
        Else
            lLineCol = &HFF000000
        End If

        bCancel = False
        lArrowCol = &HF1000000
        lLineH = (lH - 3)
        lLineY = 1
        vArr = Array(lLineCol, lLineX, lLineY, lLineH, lArrowCol)
        RaiseEvent drawEvent(DET_DROPLINE, hGraphics, vArr, bCancel)
        If (Not bCancel) Then
            If (bArrowClick) Then
                Call mUtil.fillRectGDIP(hGraphics, &H70000000, CLng(vArr(1)), 1, m_lDropDownWid, (lH - 2))
            End If
            Call mUtil.drawLine(hGraphics, CLng(vArr(1)), CLng(vArr(2)), CLng(vArr(1)), CLng(vArr(2)) + CLng(vArr(3)), , CLng(vArr(0)), , PenAlignmentCenter, LineCapFlat)
            Call mUtil.drawArrow(hGraphics, (lW - (m_lDropDownWid \ 2) - 1), ((lH - 2) \ 2), CLng(vArr(4)), m_eArrowDir)
        End If
    End If

    With rcTxtArea
        .Left = 4
        .Top = 3
        .Width = (lW - 8) - IIf((m_bDropDownStyle), m_lDropDownWid, 0)
        .Height = (lH - 6)
    End With

    bCancel = False
    If (m_oBtnIcon.hasIcon()) Then
        If (IconXYWH = "0,0,0,0") Then Call updateIconXYWHUsingIconPos(m_eIconPos)
        Call m_oBtnIcon.setDestinationXYWH((m_nIconPosArr(0) + nXOff), (m_nIconPosArr(1) + nYOff), m_nIconPosArr(2), m_nIconPosArr(3))
        Call m_oBtnIcon.setOpacity(m_bIconOpacity)
        RaiseEvent drawEvent(DET_ICON, hGraphics, m_oBtnIcon, bCancel)
        If (Not bCancel) Then Call m_oBtnIcon.drawIcon(hGraphics)
        Call updateTextArea(rcTxtArea)
    End If

    If (m_szCaption <> "") Then
        If (m_bDropDownStyle) Then
            With rcTxtArea
                If ((.Left + .Width) >= (lW - m_lDropDownWid)) Then .Width = ((lW - m_lDropDownWid) - .Left)
            End With
        End If

        bCancel = False
        nXOff = (nXOff + m_nCaptionOffsetArr(0))
        nYOff = (nYOff + m_nCaptionOffsetArr(1))
        If (Not m_bRTFEnabled) Then
            With m_oTxtPrinter
                lCol = mUtil.convertColorStructure(m_oTxtCol, [ColorRef To Color32])
                Call mUtil.replaceByte(lCol, 3, m_bTxtOpacity)
                With UserControl.Font
                    .Bold = m_bFormattingArr(m_eState, 0)
                    .Italic = m_bFormattingArr(m_eState, 1)
                    .Underline = m_bFormattingArr(m_eState, 2)
                    .Strikethrough = m_bFormattingArr(m_eState, 3)
                End With
                Call .setFontFromStdFont(UserControl.Font)
                Call .setLayoutRect((rcTxtArea.Left + nXOff), (rcTxtArea.Top + nYOff), rcTxtArea.Width, rcTxtArea.Height)
                Call .setAlignment(m_eHTxtAlign, m_eVTxtAlign)
                Call .setTextColor(lCol)
                Call .setShadowEffect(m_vShadowCol, m_nShadowOffArr(0), m_nShadowOffArr(1))
                Call .setOutlineEffect(m_vTxtOutlineCol, m_bOutlineOpacity, m_nOutlineWid)
                Call .setText(m_szCaption)
                
                RaiseEvent drawEvent(DET_TEXT, hGraphics, m_oTxtPrinter, bCancel)
                If (Not bCancel) Then Call .printText(hGraphics)
            End With
        Else
            If (Not m_oRTFPrinter.getImage().hasIcon()) Then
                lW = rcTxtArea.Width
                lH = 0
                hDCCtl = mUtil.getGraphicsContextDC(hGraphics)
                Call m_oRTFPrinter.sizeText(hDCCtl, lW, lH)
                Call mUtil.releaseGraphicsContextDC(hGraphics, hDCCtl)
                Call m_oRTFPrinter.createImage(lW, lH, &HFFFFFFFF)

                Call m_oRTFPrinter.selectAll
                m_oRTFPrinter.SelTextPara.Alignment = Choose(CInt(m_eHTxtAlign) + 1, tomAlignLeft, tomAlignCenter, tomAlignCenter)
                m_oRTFPrinter.SelTextFont.ForeColor = m_oTxtCol
                m_oRTFPrinter.SelTextFont.Name = UserControl.Font.Name
                m_oRTFPrinter.SelTextFont.Bold = m_bFormattingArr(m_eState, 0)
                m_oRTFPrinter.SelTextFont.Italic = m_bFormattingArr(m_eState, 1)
                m_oRTFPrinter.SelTextFont.Underline = m_bFormattingArr(m_eState, 2)
                m_oRTFPrinter.SelTextFont.Strikethrough = m_bFormattingArr(m_eState, 3)
                m_oRTFPrinter.SelTextFont.Size = UserControl.Font.Size
                Call m_oRTFPrinter.selectNone
            End If
            With m_oRTFPrinter.getImage()
                .DestX = (rcTxtArea.Left + nXOff)
                .DestY = (rcTxtArea.Top + nYOff)

                RaiseEvent drawEvent(DET_TEXT, hGraphics, m_oRTFPrinter, bCancel)
                If (Not bCancel) Then
                    If (m_bTxtOpacity = 255) Then
                        hDCCtl = mUtil.getGraphicsContextDC(hGraphics)
                        Call m_oRTFPrinter.drawText(hDCCtl, .DestX, .DestY, .Width, .Height)
                        Call mUtil.releaseGraphicsContextDC(hGraphics, hDCCtl)
                    Else
                        .Opacity = m_bTxtOpacity
                        Call .drawIcon(hGraphics)
                    End If
                End If
            End With
        End If
    End If
    
EH:
    RaiseEvent drawEvent(DET_REFRESH, hGraphics, Empty, False)
    Call mUtil.deleteGraphicsContext(hGraphics)
    Call UserControl.Refresh
    If (Not m_bDoubleBuffer) Then UserControl.AutoRedraw = False
    
    With m_tPrevState
        .eBtnState = m_eState
        .sW = UserControl.Width
        .sH = UserControl.Height
    End With
    
    If (Err.Number) Then
        'Call MsgBox(Err.Description)
        Call Err.Clear
    End If
    
    'm_bBusy = False
End Function

Public Function updateIconXYWHUsingIconPos(ByVal ePos As EIconPos)
    Dim nTxtWid As Integer, nTxtHei As Integer, nCtlWid As Integer, nCtlHei As Integer, szCap As String, nX As Integer, nY As Integer, _
        nFreeW As Integer, nFreeH As Integer, sIconW As Single, sIconH As Single, lIconWid As Long, lIconHei As Long, nDiffW As Integer, _
        nDiffH As Integer
    
    szCap = Replace(m_szCaption, "\n", vbCrLf)
    nTxtWid = (UserControl.TextWidth(szCap) \ Screen.TwipsPerPixelX)
    nTxtHei = CInt((UserControl.TextHeight(szCap) \ Screen.TwipsPerPixelY) * 1.15)
    nCtlWid = (UserControl.Width \ Screen.TwipsPerPixelX)
    nCtlHei = (UserControl.Height \ Screen.TwipsPerPixelY)
    nFreeW = (nCtlWid - nTxtWid) - IIf((m_bDropDownStyle), m_lDropDownWid, 0)
    nFreeH = (nCtlHei - nTxtHei)
    sIconW = m_oBtnIcon.Width
    sIconH = m_oBtnIcon.Height
    
    If (m_bAutoSizeIcon) Then
        lIconWid = CLng(sIconW)
        lIconHei = CLng(sIconH)
        If ((ePos = IP_LEFT) Or (ePos = IP_RIGHT)) Then nDiffW = nTxtWid
        If ((ePos = IP_TOP) Or (ePos = IP_BOTTOM)) Then nDiffH = nTxtHei
        Call getConstrainedSize(lIconWid, lIconHei, (nCtlWid - nDiffW), (nCtlHei - nDiffH))
        sIconW = CSng(lIconWid)
        sIconH = CSng(lIconHei)
    End If
    
    Select Case ePos
        Case EIconPos.IP_LEFT
            nX = 6
            nY = (nCtlHei - sIconH) \ 2
            
        Case EIconPos.IP_TOP
            nX = (nCtlWid - sIconW) \ 2
            nY = (nFreeH - sIconH) \ 2
            
        Case EIconPos.IP_RIGHT
            nX = (nCtlWid - 5 - sIconW - IIf((m_bDropDownStyle), m_lDropDownWid, 0))
            nY = (nCtlHei - sIconH) \ 2
        
        Case EIconPos.IP_BOTTOM
            nX = (nCtlWid - sIconW) \ 2
            nY = nTxtHei + ((nFreeH - sIconH) \ 2)
            
        Case EIconPos.IP_CENTER
            nX = (nCtlWid - sIconW) \ 2
            nY = (nCtlHei - sIconH) \ 2
    End Select
    
    m_nIconPosArr(0) = nX
    m_nIconPosArr(1) = nY
    m_nIconPosArr(2) = sIconW
    m_nIconPosArr(3) = sIconH
End Function

Public Function getConstrainedSize(ByRef lSrcWid As Long, ByRef lSrcHei As Long, ByVal lDestWid As Long, ByVal lDestHei As Long)
    Dim sSrcRatio As Double, sDestRatio As Double, lNewWid As Long, lNewHei As Long
    
    sSrcRatio = (lSrcWid / lSrcHei)
    sDestRatio = (lDestWid / lDestHei)
    lNewWid = lDestWid
    lNewHei = lDestHei
    
    If ((lSrcWid <= lDestWid) And (lSrcHei <= lDestHei)) Then
        lNewWid = lSrcWid
        lNewHei = lSrcHei
    ElseIf (sDestRatio < sSrcRatio) Then
        lNewHei = (lDestWid / lSrcWid) * lSrcHei
    Else
        lNewWid = (lDestHei / lSrcHei) * lSrcWid
    End If
    
    lSrcWid = lNewWid
    lSrcHei = lNewHei
End Function

Private Function updateTextArea(ByRef rcArea As RECTL)
    Dim lW As Long, lH As Long
    
    lW = (UserControl.Width \ Screen.TwipsPerPixelX)
    lH = (UserControl.Height \ Screen.TwipsPerPixelY)
    
    With rcArea
        Select Case m_eIconPos
            Case EIconPos.IP_LEFT
                .Left = (m_nIconPosArr(0) + m_nIconPosArr(2) + 2)
                .Top = 2
                .Width = (lW - .Left)
                .Height = (lH - 4)
                
            Case EIconPos.IP_TOP
                .Left = 2
                .Top = (m_nIconPosArr(1) + m_nIconPosArr(3)) + 2
                .Width = (lW - .Left)
                .Height = (lH - .Top)
                
            Case EIconPos.IP_RIGHT
                .Left = 3
                .Top = 2
                .Width = (m_nIconPosArr(0) - .Left)
                .Height = (lH - .Top)
                
            Case EIconPos.IP_BOTTOM
                .Left = 3
                .Top = 2
                .Width = (lW - .Left)
                .Height = (m_nIconPosArr(1) - .Top)
                
            Case EIconPos.IP_CENTER
                .Left = 3
                .Top = 2
                .Width = (lW - 6)
                .Height = (lH - 4)
        End Select
    End With
End Function

Private Function resetIconProperties()
    m_nIconPosArr(0) = 0
    m_nIconPosArr(1) = 0
    m_nIconPosArr(2) = 0
    m_nIconPosArr(3) = 0
End Function

Public Function isArrowClick(ByVal lMinX As Long)
    Dim lX As Long, lY As Long
    
    Call mUtil.getCursorPosition(lX, lY, UserControl.hWnd)
    isArrowClick = ((m_eState = PBS_PRESSED) And (lX >= lMinX) And (lY >= 0) And (lY <= (UserControl.Height \ Screen.TwipsPerPixelY)))
End Function

'===============================================================================================================================================
' E O F ----------------------------------------------------------------------------------------------------------------------- X I P H I A S 3
'===============================================================================================================================================
























