VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "X3RTFPrinter"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' X3RTFPrinter
' December 2009

Option Explicit

Private Declare Function AlphaBlend Lib "msimg32.dll" (ByVal hDCDest As Long, ByVal xDest As Long, ByVal yDest As Long, ByVal WidthDest As Long, ByVal HeightDest As Long, ByVal hDCSrc As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal WidthSrc As Long, ByVal HeightSrc As Long, ByVal Blendfunc As Long) As Long
Private Type BLENDFUNCTION
    BlendOp             As Byte
    BlendFlags          As Byte
    SourceConstantAlpha As Byte
    AlphaFormat         As Byte
End Type
Private Type RGBQUAD
    rgbBlue     As Byte
    rgbGreen    As Byte
    rgbRed      As Byte
    rgbReserved As Byte
End Type

Private Const AC_SRC_ALPHA As Long = &H1
Private Const AC_SRC_OVER  As Long = &H0
Private Const HALFTONE     As Long = 4
Private Declare Function SetStretchBltMode Lib "gdi32.dll" (ByVal hdc As Long, ByVal nStretchMode As Long) As Long

'UINT    __stdcall RTP_Initialize();
'BOOL    __stdcall RTP_Terminate(UINT uiID);
'VOID    __stdcall RTP_SetText(UINT uiID, LPCWSTR lpwszText);
'VOID    __stdcall RTP_SizeText(UINT uiID, HDC hDC, RECT* rect);
'BOOL    __stdcall RTP_DrawText(UINT uiID, HDC hDC, RECT* rect);
'HRESULT __stdcall RTP_SendMessage(UINT uiID, UINT msg, WPARAM wparam, LPARAM lparam, LRESULT* plresult);
'BOOL    __stdcall RTP_DrawTextL(UINT uiID, HDC hDC, LONG lX, LONG lY, LONG lW, LONG lH);
'VOID    __stdcall RTP_SizeTextL(UINT uiID, HDC hDC, LONG* lpW, LONG* lpH);
'LONG    __stdcall RTP_GetTextLength(UINT uiID);
'VOID    __stdcall RTP_SelectAll(UINT uiID);
'VOID    __stdcall RTP_SelectNone(UINT uiID);
'VOID    __stdcall RTP_SelectRange(UINT uiID, long cpMin, long cpMax);
'LONG    __stdcall RTP_GetSelectedTextLength(UINT uiID);
'void    __stdcall RTP_GetRTFText(UINT uiID, BOOL bSelectionOnly, IStream** ppStream, ULONG* ulStrLen);
'HRESULT __stdcall RTP_SetRTFText(UINT uiID, BOOL bSelectionOnly, LPSTR lpszRTFText)

Private Declare Function RTP_Initialize Lib "X3RichTextPrinter.dll" () As Long
Private Declare Function RTP_Terminate Lib "X3RichTextPrinter.dll" (ByVal uiID As Long) As Long
Private Declare Function RTP_DrawTextL Lib "X3RichTextPrinter.dll" (ByVal uiID As Long, ByVal hdc As Long, ByVal lX As Long, ByVal lY As Long, ByVal lW As Long, ByVal lH As Long) As Long
Private Declare Function RTP_DrawText Lib "X3RichTextPrinter.dll" (ByVal uiID As Long, ByVal hdc As Long, ByVal pRect As Long) As Long
Private Declare Function RTP_SendMessage Lib "X3RichTextPrinter.dll" (ByVal uiID As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long, ByRef plresult As Long) As Long
Private Declare Function RTP_GetTextLength Lib "X3RichTextPrinter.dll" (ByVal uiID As Long) As Long
Private Declare Function RTP_GetSelectedTextLength Lib "X3RichTextPrinter.dll" (ByVal uiID As Long) As Long
Private Declare Sub RTP_SelectAll Lib "X3RichTextPrinter.dll" (ByVal uiID As Long)
Private Declare Sub RTP_SelectNone Lib "X3RichTextPrinter.dll" (ByVal uiID As Long)
Private Declare Sub RTP_SelectRange Lib "X3RichTextPrinter.dll" (ByVal uiID As Long, ByVal cpMin As Long, ByVal cpMax As Long)
Private Declare Sub RTP_SizeTextL Lib "X3RichTextPrinter.dll" (ByVal uiID As Long, ByVal hdc As Long, ByRef lpW As Long, ByRef lpH As Long)
Private Declare Sub RTP_SetText Lib "X3RichTextPrinter.dll" (ByVal uiID As Long, ByVal pwszText As Long)
Private Declare Sub RTP_SizeText Lib "X3RichTextPrinter.dll" (ByVal uiID As Long, ByVal hdc As Long, ByVal pRect As Long)
Private Declare Function RTP_SetRTFText Lib "X3RichTextPrinter.dll" (ByVal uiID As Long, ByVal bSelectionOnly As Long, ByVal lpszRTFText As Long) As Long
Private Declare Sub RTP_GetRTFText Lib "X3RichTextPrinter.dll" (ByVal uiID As Long, ByVal bSelectionOnly As Long, ByVal ppStream As Long, ByRef ulStrLen As Long)

Private Const WM_USER            As Long = &H400
Private Const EM_GETOLEINTERFACE As Long = (WM_USER + 60)

Private m_pRichEd  As IRichEditOle
Private m_pDoc     As ITextDocument
Private m_oTxtIcon As X3BIcon
Private m_lRTFID   As Long
Private m_szTag    As String

Public Property Get Tag() As String
    Tag = m_szTag
End Property
Public Property Let Tag(ByVal szVal As String)
    m_szTag = szVal
End Property

Private Sub Class_Initialize()
    ' Create Windowless RichText interface
    m_lRTFID = RTP_Initialize
    ' Retrieve the IRichEditOle interface
    Call RTP_SendMessage(m_lRTFID, EM_GETOLEINTERFACE, 0, VarPtr(m_pRichEd), ByVal 0)
    ' QueryInterface -> ITextDocument
    Set m_pDoc = m_pRichEd
    Set m_oTxtIcon = New X3BIcon
End Sub

Private Sub Class_Terminate()
    ' Release pointers BEFORE Terminating Windowless RichText interface
    Set m_pDoc = Nothing
    Set m_pRichEd = Nothing
    Set m_oTxtIcon = Nothing
    Call RTP_Terminate(m_lRTFID)
End Sub

Public Property Get Text() As String
    Dim pRange As ITextRange
    
    Set pRange = m_pDoc.Range(0, -1)
    Text = pRange.Text
End Property
Public Property Let Text(ByRef szTxt As String)
    Call RTP_SetText(m_lRTFID, StrPtr(szTxt))
End Property

Public Property Get TextLength() As Long
    TextLength = RTP_GetTextLength(m_lRTFID)
End Property

Public Property Get SelTextLength() As Long
    SelTextLength = RTP_GetSelectedTextLength(m_lRTFID)
End Property

Public Property Get Document() As ITextDocument
    Set Document = m_pDoc
End Property

Public Property Get SelTextRange() As ITextSelection
    Set SelTextRange = m_pDoc.Selection
End Property

Public Property Get SelTextFont() As ITextFont
    Dim pSel As ITextSelection
    
    Set pSel = m_pDoc.Selection
    If (Not pSel Is Nothing) Then Set SelTextFont = pSel.Font Else Set SelTextFont = Nothing
End Property

Public Property Get SelTextPara() As ITextPara
    Dim pSel As ITextSelection
    
    Set pSel = m_pDoc.Selection
    If (Not pSel Is Nothing) Then Set SelTextPara = pSel.Para Else Set SelTextPara = Nothing
End Property

Public Function sendMessage(ByVal uiMsg As Long, ByVal wParam As Long, ByVal lParam As Long, ByRef lpResult As Long) As Long
    sendMessage = RTP_SendMessage(m_lRTFID, uiMsg, wParam, lParam, lpResult)
End Function

Public Function selectAll()
    Call RTP_SelectAll(m_lRTFID)
End Function

Public Function selectNone()
    Call RTP_SelectNone(m_lRTFID)
End Function

Public Function selectRange(ByVal lMin As Long, ByVal lMax As Long)
    Call RTP_SelectRange(m_lRTFID, lMin, lMax)
End Function

Public Function sizeText(ByVal hdc As Long, ByRef lDestWid As Long, ByRef lHei As Long)
    Call RTP_SizeTextL(m_lRTFID, hdc, lDestWid, lHei)
End Function

Public Function drawText(ByVal hdc As Long, ByVal lX As Long, ByVal lY As Long, ByVal lW As Long, ByVal lH As Long) As Long
    drawText = RTP_DrawTextL(m_lRTFID, hdc, lX, lY, lW, lH)
End Function

Public Function getImage() As Object
    Set getImage = m_oTxtIcon
End Function

Public Function getRTF(ByVal bSelOnly As Boolean) As String
    Dim pStream As IStream, szRTF As String, lStrLen As Long
    
    Set pStream = CreateStreamOnHGlobal(0, 1)
    If (Not pStream Is Nothing) Then
        Call RTP_GetRTFText(m_lRTFID, IIf((bSelOnly), 1, 0), VarPtr(pStream), lStrLen)
        szRTF = StrConv(String(lStrLen, vbNullChar), vbFromUnicode)
        Call pStream.Read(ByVal StrPtr(szRTF), lStrLen)
        Set pStream = Nothing
        szRTF = StrConv(szRTF, vbUnicode)
    End If
    getRTF = szRTF
End Function

Public Function setRTF(ByVal bSelOnly As Boolean, ByRef szRTF As String)
    Dim lRet As Long
    
    lRet = RTP_SetRTFText(m_lRTFID, IIf((bSelOnly), 1, 0), StrPtr(StrConv(szRTF + vbNullChar, vbFromUnicode)))
End Function

Public Function clearImage()
    Call m_oTxtIcon.dispose
End Function

'http://www.vbaccelerator.com/home/VB/Code/vbMedia/Image_Processing/Blurring__Sharpening_and_Embossing/article.asp
'---> Blurring and Smoothing Filters <---
'Blurring or smoothing filers are known as low-pass filters. (Incidentally, the same concept can be applied to audio files;
'a low-pass filter has the effect of removing the higher frequencies, to allow you to produce radio or telephone style effects).
'To implement this type of filter, you add a contribution from the neighbouring pixels and reduce the contribution from the pixel itself.
'Here is an example blurring filter:
'1/9 1/9 1/9
'1/9 1/9 1/9
'1/9 1/9 1/9
'
'To understand how this works in practice its easier to see what it does. So, say we had a red pixel (RGB 0,0,255) surrounded by blue
'pixels (RGB 255,0,0) in a bitmap:
'..  (0,0,255)   (0,0,255)   (0,0,255)   ..
'..  (0,0,255)   (255,0,0)   (0,0,255)   ..
'..  (0,0,255)   (0,0,255)   (0,0,255)   ..
'..
'The result for the centre pixel will be the sum of 1/9 of each of the pixel's values, i.e. (255/9),0,8x(255/9) = (31.9, 0, 216.7)
'This is a mostly blue purple colour, so the single red value has been blurred by its blue neighbours to a bluer shade.
'Normally, rather than expressing the filter in terms of floating point values (i.e. 1/9), we use integers to express the filter values
'and then give the filter an integer weight. The integer matrix is used for multiplication and the final values are divided by the weight.
'So the 3x3 matrix above is written:
'1   1   1   Weight: 9
'1   1   1
'1   1   1
'You can modify the filter to blur more by increasing the number of pixels that are sampled in the matrix (e.g. use a 5x5 or 7x7 matrix
'rather than a 3x3 one) and by increasing the contribution for the pixels surrounding the central one.
'To decrease the blurring effect and get a softening effect, increase the weight of the contribution from the central pixel:
'1   1   1   Weight: 18
'1   10  1
'1   1   1
Public Function createImage(ByVal lW As Long, ByVal lH As Long, Optional ByVal lBlendCol32 As Long = &HFF7F7F7F)
    Dim hDIB As Long, lBF As Long, tBF As BLENDFUNCTION, lRet As Long, lpBits As Long, hDCMem As Long, hBmpPrev As Long, tBGRA() As RGBQUAD, _
        lIndx As Long, lImgSize As Long, hImg As Long, hGraphics As Long, hDCImg As Long, tBlurEffectMatrixArr() As RGBQUAD, i As Integer, _
        lPxCompValArr(2) As Long, lTargetIndx As Long, tEmptyPx As RGBQUAD, szHex As String, nWeightArr(8) As Integer, bSetupFilter As Boolean, _
        nTotalWeight As Integer
    
'    AC_SRC_ALPHA
'    This flag is set when the bitmap has an Alpha channel (that is, per-pixel alpha). Note that the APIs use premultiplied alpha,
'    which means that the red, green and blue channel values in the bitmap must be premultiplied with the alpha channel value. For example,
'    if the alpha channel value is x, the red, green and blue channels must be multiplied by x and divided by 0xff prior to the call.
'   lBlendCol32 will be used to identify the background, so no text should have this color.
    With tBF
        .AlphaFormat = AC_SRC_ALPHA
        .BlendFlags = 0
        .BlendOp = AC_SRC_OVER
        ' Set to 255 to use source per pixel alpha values
        .SourceConstantAlpha = 255
    End With
    Call mUtil.CopyMemory(lBF, tBF, 4)
    
    hDIB = mUtil.createDIB(lW, lH, 32, lpBits)
    hDCMem = mUtil.CreateCompatibleDC(0)
    hBmpPrev = mUtil.SelectObject(hDCMem, hDIB)
    
    bSetupFilter = True
    hGraphics = mUtil.getGraphicsContext(hDCMem)
    Call mUtil.fillRectGDIP(hGraphics, lBlendCol32, 0, 0, lW, lH)
    Call mUtil.deleteGraphicsContext(hGraphics)
    
    lRet = drawText(hDCMem, 0, 0, lW, lH)
    lImgSize = (lW * lH * 4&)
    ReDim tBGRA((lW * lH) - 1)
    Call mUtil.CopyMemory(tBGRA(0), ByVal lpBits, lImgSize)
    
    For lIndx = 0 To UBound(tBGRA) Step 1
        If (bSetupFilter) Then
            ReDim tBlurEffectMatrixArr(0 To 8)
            szHex = Right("0000000" + Hex(lBlendCol32), 8)
            'The empty pixel matches the BG col and will be used for blurring
            With tEmptyPx
                .rgbBlue = CByte("&H" + Mid(szHex, 3, 2))
                .rgbGreen = CByte("&H" + Mid(szHex, 5, 2))
                .rgbRed = CByte("&H" + Mid(szHex, 7, 2))
                .rgbReserved = 0
            End With
            
            nWeightArr(0) = 1
            nWeightArr(1) = 1
            nWeightArr(2) = 1
            nWeightArr(3) = 1
            nWeightArr(4) = 10
            nWeightArr(5) = 1
            nWeightArr(6) = 1
            nWeightArr(7) = 1
            nWeightArr(8) = 1
            nTotalWeight = 18
            
            bSetupFilter = False
        End If
        
        With tBGRA(lIndx)
            If ((.rgbBlue = tEmptyPx.rgbBlue) And (.rgbGreen = tEmptyPx.rgbGreen) And (.rgbRed = tEmptyPx.rgbRed)) Then
                .rgbReserved = 0
            Else
                .rgbReserved = 255
            End If
        End With
        
        For i = 0 To UBound(nWeightArr) Step 1
            Select Case i
                Case 0: lTargetIndx = (lIndx - lW - 1)
                Case 1: lTargetIndx = (lIndx - lW)
                Case 2: lTargetIndx = (lIndx - lW + 1)
                
                Case 3: lTargetIndx = (lIndx - 1)
                Case 4: lTargetIndx = (lIndx)
                Case 5: lTargetIndx = (lIndx + 1)
                
                Case 6: lTargetIndx = (lIndx + lW - 1)
                Case 7: lTargetIndx = (lIndx + lW)
                Case 8: lTargetIndx = (lIndx + lW + 1)
            End Select
            If ((lTargetIndx >= 0) And (lTargetIndx <= UBound(tBGRA))) Then
                tBlurEffectMatrixArr(8) = tBGRA(lTargetIndx)
            Else
                tBlurEffectMatrixArr(i) = tEmptyPx
            End If
            lTargetIndx = (lTargetIndx + 1)
        Next i
        
        lPxCompValArr(0) = 0
        lPxCompValArr(1) = 0
        lPxCompValArr(2) = 0
        For i = 0 To UBound(tBlurEffectMatrixArr) Step 1
            lPxCompValArr(0) = lPxCompValArr(0) + (tBlurEffectMatrixArr(i).rgbBlue * nWeightArr(i))
            lPxCompValArr(1) = lPxCompValArr(1) + (tBlurEffectMatrixArr(i).rgbGreen * nWeightArr(i))
            lPxCompValArr(2) = lPxCompValArr(2) + (tBlurEffectMatrixArr(i).rgbRed * nWeightArr(i))
        Next i
        
        lPxCompValArr(0) = (lPxCompValArr(0) \ nTotalWeight)
        lPxCompValArr(1) = (lPxCompValArr(1) \ nTotalWeight)
        lPxCompValArr(2) = (lPxCompValArr(2) \ nTotalWeight)
        With tBGRA(lIndx)
            .rgbBlue = lPxCompValArr(0)
            .rgbGreen = lPxCompValArr(1)
            .rgbRed = lPxCompValArr(2)
        End With
        
        tBGRA(lIndx).rgbBlue = (CLng(tBGRA(lIndx).rgbBlue) * CLng(tBGRA(lIndx).rgbReserved)) \ 255
        tBGRA(lIndx).rgbGreen = (CLng(tBGRA(lIndx).rgbGreen) * CLng(tBGRA(lIndx).rgbReserved)) \ 255
        tBGRA(lIndx).rgbRed = (CLng(tBGRA(lIndx).rgbRed) * CLng(tBGRA(lIndx).rgbReserved)) \ 255
    Next lIndx
    Call mUtil.CopyMemory(ByVal lpBits, tBGRA(0), lImgSize)
    
    hImg = mUtil.createImage(lW, lH, PixelFormat32bppARGB)
    hGraphics = mUtil.getImageGraphicsContext(hImg)
    Call mUtil.setAAGraphicsSmoothingMode(hGraphics)
    hDCImg = mUtil.getGraphicsContextDC(hGraphics)
    lRet = AlphaBlend(hDCImg, 0, 0, lW, lH, hDCMem, 0, 0, lW, lH, lBF)
    Call mUtil.releaseGraphicsContextDC(hGraphics, hDCImg)
    Call mUtil.deleteGraphicsContext(hGraphics)
    Call mUtil.SelectObject(hDCMem, hBmpPrev)
    Call mUtil.DeleteDC(hDCMem)
    Call mUtil.DeleteObject(hDIB)
    
    Call clearImage
    Call m_oTxtIcon.setIconImage(hImg)
End Function



















