Attribute VB_Name = "mUtil"
Option Explicit

Private Enum ColorMatrixFlags
    ColorMatrixFlagsDefault = &H0
    ColorMatrixFlagsSkipGrays = &H1
    ColorMatrixFlagsAltGray = &H2
End Enum

Private Enum ColorAdjustType
    ColorAdjustTypeDefault = &H0
    ColorAdjustTypeBitmap = &H1
    ColorAdjustTypeBrush = &H2
    ColorAdjustTypePen = &H3
    ColorAdjustTypeText = &H4
    ColorAdjustTypeCount = &H5
    ColorAdjustTypeAny = &H6
End Enum

Public Enum GpStatus
    Ok = &H0
    GenericError = &H1
    InvalidParameter = &H2
    OutOfMemory = &H3
    ObjectBusy = &H4
    InsufficientBuffer = &H5
    NotImplemented = &H6
    Win32Error = &H7
    WrongState = &H8
    Aborted = &H9
    FileNotFound = &HA
    ValueOverflow = &HB
    AccessDenied = &HC
    UnknownImageFormat = &HD
    FontFamilyNotFound = &HE
    FontStyleNotFound = &HF
    NotTrueTypeFont = &H10
    UnsupportedlusVersion = &H11
    lusNotInitialized = &H12
    PropertyNotFound = &H13
    PropertyNotSupported = &H14
End Enum

Private Type GdiplusStartupInput
    GdiplusVersion As Long
    DebugEventCallback As Long
    SuppressBackgroundThread As Long
    SuppressExternalCodecs As Long
End Type

Private Enum GpUnit
    UnitWorld = &H0
    UnitDisplay = &H1
    UnitPixel = &H2
    UnitPoint = &H3
    UnitInch = &H4
    UnitDocument = &H5
    UnitMillimeter = &H6
End Enum

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Public Enum EPushButtonState
    PBS_NORMAL
    PBS_HOT
    PBS_PRESSED
    PBS_DISABLED
    PBS_FOCUS
End Enum

Public Enum EConversionMode
    [ColorRef To Color32]
    [Color32 To ColorRef]
End Enum

Public Declare Function LoadCursor Lib "user32.dll" Alias "LoadCursorA" (ByVal hInstance As Long, ByRef lpCursorName As Any) As Long
Public Const IDC_HAND As Long = 32649

Private Declare Sub ZeroMemory Lib "kernel32.dll" Alias "RtlZeroMemory" (ByRef Destination As Any, ByVal Length As Long)
Private Declare Sub FillMemory Lib "kernel32.dll" Alias "RtlFillMemory" (ByRef Destination As Any, ByVal Length As Long, ByVal Fill As Byte)

Private Declare Function GdipSetCompositingMode Lib "GdiPlus.dll" (ByVal mGraphics As Long, ByRef mCompositingMode As CompositingMode) As GpStatus
Private Declare Function GdipSetCompositingQuality Lib "GdiPlus.dll" (ByVal mGraphics As Long, ByVal mCompositingQuality As CompositingQuality) As GpStatus
Private Enum CompositingMode
    CompositingModeSourceOver = &H0
    CompositingModeSourceCopy = &H1
End Enum
Private Enum CompositingQuality
    CompositingQualityInvalid = &HFFFFFFFF
    CompositingQualityDefault = &H0
    CompositingQualityHighSpeed = &H1
    CompositingQualityHighQuality = &H2
    CompositingQualityGammaCorrected = &H3
    CompositingQualityAssumeLinear = &H4
End Enum
Private Enum InterpolationMode
    InterpolationModeInvalid = &HFFFFFFFF
    InterpolationModeDefault = &H0
    InterpolationModeLowQuality = &H1
    InterpolationModeHighQuality = &H2
    InterpolationModeBilinear = &H3
    InterpolationModeBicubic = &H4
    InterpolationModeNearestNeighbor = &H5
    InterpolationModeHighQualityBilinear = &H6
    InterpolationModeHighQualityBicubic = &H7
End Enum

Private Declare Function GdipSetInterpolationMode Lib "GdiPlus.dll" (ByVal mGraphics As Long, ByVal mInterpolationMode As InterpolationMode) As GpStatus
Private Declare Function GetParent Lib "user32.dll" (ByVal hWnd As Long) As Long
Private Declare Function GetForegroundWindow Lib "user32.dll" () As Long
Private Declare Function SetFocusAPI Lib "user32.dll" Alias "SetFocus" (ByVal hWnd As Long) As Long
Private Declare Function GetWindowThreadProcessId Lib "user32.dll" (ByVal hWnd As Long, ByRef lpdwProcessId As Long) As Long
Private Declare Function AttachThreadInput Lib "user32.dll" (ByVal idAttach As Long, ByVal idAttachTo As Long, ByVal fAttach As Long) As Long
Private Declare Function SetForegroundWindow Lib "user32.dll" (ByVal hWnd As Long) As Long

Private Declare Function GdipBitmapGetPixel Lib "GdiPlus.dll" (ByVal mBitmap As Long, ByVal mX As Long, ByVal mY As Long, ByRef mColor As Long) As GpStatus

Public Declare Function SetCapture Lib "user32.dll" (ByVal hWnd As Long) As Long
Public Declare Function GetCapture Lib "user32.dll" () As Long
Public Declare Function ReleaseCapture Lib "user32.dll" () As Long

Private Declare Function GdiplusStartup Lib "GdiPlus.dll" (ByRef mtoken As Long, ByRef mInput As GdiplusStartupInput, ByRef mOutput As Any) As GpStatus
Private Declare Sub GdiplusShutdown Lib "GdiPlus.dll" (ByVal mtoken As Long)

Private Declare Function GdipCreateBitmapFromFile Lib "GdiPlus.dll" (ByVal mFilename As String, ByRef mBitmap As Long) As GpStatus
Private Declare Function GdipCreateBitmapFromResource Lib "GdiPlus.dll" (ByVal mHInstance As Long, ByVal mBitmapName As String, ByRef mBitmap As Long) As GpStatus
Private Declare Function GdipDisposeImage Lib "GdiPlus.dll" (ByVal mImage As Long) As GpStatus

Private Declare Function IsTextUnicode Lib "advapi32.dll" (ByRef lpBuffer As Any, ByVal cb As Long, ByRef lpi As Long) As Long

Private Declare Function GdipGetImageDimension Lib "GdiPlus.dll" (ByVal mImage As Long, ByRef mWidth As Single, ByRef mHeight As Single) As GpStatus
Private Declare Function GdipDrawImagePointRect Lib "GdiPlus.dll" (ByVal mGraphics As Long, ByVal mImage As Long, ByVal mX As Single, ByVal mY As Single, ByVal mSrcx As Single, ByVal mSrcy As Single, ByVal mSrcwidth As Single, ByVal mSrcheight As Single, ByVal mSrcUnit As GpUnit) As GpStatus
Private Declare Function GdipDrawImageRectRectI Lib "GdiPlus.dll" (ByVal mGraphics As Long, ByVal mImage As Long, ByVal mDstx As Long, ByVal mDsty As Long, ByVal mDstwidth As Long, ByVal mDstheight As Long, ByVal mSrcx As Long, ByVal mSrcy As Long, ByVal mSrcwidth As Long, ByVal mSrcheight As Long, ByVal mSrcUnit As GpUnit, ByRef mImageAttributes As Long, ByRef mcallback As Long, ByRef mcallbackData As Long) As GpStatus
Public Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" (ByRef Destination As Any, ByRef Source As Any, ByVal Length As Long)

Private Declare Function GdipCreateFromHDC Lib "GdiPlus.dll" (ByVal mhDC As Long, ByRef mGraphics As Long) As GpStatus
Private Declare Function GdipDeleteGraphics Lib "GdiPlus.dll" (ByVal mGraphics As Long) As GpStatus
Private Declare Function GetWindowRect Lib "user32.dll" (ByVal hWnd As Long, ByRef lpRect As RECT) As Long
Private Declare Function ClientToScreen Lib "user32.dll" (ByVal hWnd As Long, ByRef lpPoint As POINTAPI) As Long
Private Declare Function BitBlt Lib "gdi32.dll" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Declare Function ReleaseDC Lib "user32.dll" (ByVal hWnd As Long, ByVal hdc As Long) As Long
Private Declare Function GetWindowDC Lib "user32.dll" (ByVal hWnd As Long) As Long
Private Declare Function GdipGetDC Lib "GdiPlus.dll" (ByVal mGraphics As Long, ByRef mhDC As Long) As GpStatus
Private Declare Function GdipReleaseDC Lib "GdiPlus.dll" (ByVal mGraphics As Long, ByVal mhDC As Long) As GpStatus
Private Declare Function PtInRect Lib "user32.dll" (ByRef lpRect As RECT, ByVal x As Long, ByVal y As Long) As Long
Private Const SRCCOPY As Long = &HCC0020

Private Declare Function GdipCreateSolidFill Lib "GdiPlus.dll" (ByVal mColor As Long, ByRef mBrush As Long) As GpStatus
Private Declare Function GdipFillRectangleI Lib "GdiPlus.dll" (ByVal mGraphics As Long, ByVal mBrush As Long, ByVal mX As Long, ByVal mY As Long, ByVal mWidth As Long, ByVal mHeight As Long) As GpStatus
Private Declare Function OleTranslateColor Lib "oleaut32.dll" (ByVal lOleColor As Long, ByVal lHPalette As Long, ByRef lColorRef As Long) As Long
Private Declare Function OffsetRect Lib "user32.dll" (ByRef lpRect As RECT, ByVal x As Long, ByVal y As Long) As Long

Private Declare Function GdipCreateImageAttributes Lib "GdiPlus.dll" (ByRef mImageattr As Long) As GpStatus
Private Declare Function GdipDisposeImageAttributes Lib "GdiPlus.dll" (ByVal mImageattr As Long) As GpStatus
Private Declare Function GdipSetImageAttributesColorMatrix Lib "GdiPlus.dll" (ByVal mImageattr As Long, ByVal mType As ColorAdjustType, ByVal mEnableFlag As Long, ByRef mGpColorMatrix As ColorMatrix, ByRef mGrayMatrix As ColorMatrix, ByVal mFlags As ColorMatrixFlags) As GpStatus
Private Type ColorMatrix
    m(0 To 4, 0 To 4) As Single
End Type

Private Declare Function ScreenToClient Lib "user32.dll" (ByVal hWnd As Long, ByRef lpPoint As POINTAPI) As Long
Private Declare Function GetCursorPos Lib "user32.dll" (ByRef lpPoint As POINTAPI) As Long
Private Type POINTAPI
    x As Long
    y As Long
End Type

Private Declare Function FillRect Lib "user32.dll" (ByVal hdc As Long, ByRef lpRect As RECT, ByVal hBrush As Long) As Long
Private Declare Function CreateSolidBrush Lib "gdi32.dll" (ByVal crColor As Long) As Long
Private Declare Function SetRect Lib "user32.dll" (ByRef lpRect As RECT, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long

Private Declare Function GdipCreatePen1 Lib "GdiPlus.dll" (ByVal mColor As Long, ByVal mWidth As Single, ByVal mUnit As GpUnit, ByRef mPen As Long) As GpStatus
Private Declare Function GdipDeletePen Lib "GdiPlus.dll" (ByVal mPen As Long) As GpStatus
Private Declare Function GdipSetPenStartCap Lib "GdiPlus.dll" (ByVal mPen As Long, ByVal mStartCap As LineCap) As GpStatus
Private Declare Function GdipSetPenMode Lib "GdiPlus.dll" (ByVal mPen As Long, ByVal mPenMode As PenAlignment) As GpStatus
Private Declare Function GdipSetPenEndCap Lib "GdiPlus.dll" (ByVal mPen As Long, ByVal mEndCap As LineCap) As GpStatus
Private Declare Function GdipDrawLineI Lib "GdiPlus.dll" (ByVal mGraphics As Long, ByVal mPen As Long, ByVal mX1 As Long, ByVal mY1 As Long, ByVal mX2 As Long, ByVal mY2 As Long) As GpStatus
Private Declare Function GdipCreatePathGradientI Lib "GdiPlus.dll" (ByRef mPoints As POINTL, ByVal mCount As Long, ByVal mWrapMode As WrapMode, ByRef mPolyGradient As Long) As GpStatus
Private Type POINTL
    x As Long
    y As Long
End Type

Private Declare Function GdipSetTextRenderingHint Lib "GdiPlus.dll" (ByVal mGraphics As Long, ByVal mMode As TextRenderingHint) As GpStatus
Private Enum TextRenderingHint
    TextRenderingHintSystemDefault = &H0
    TextRenderingHintSingleBitPerPixelGridFit = &H1
    TextRenderingHintSingleBitPerPixel = &H2
    TextRenderingHintAntiAliasGridFit = &H3
    TextRenderingHintAntiAlias = &H4
    TextRenderingHintClearTypeGridFit = &H5
End Enum

Private Declare Function GdipDeleteBrush Lib "GdiPlus.dll" (ByVal mBrush As Long) As GpStatus
Private Declare Function GdipSetPathGradientBlend Lib "GdiPlus.dll" (ByVal mBrush As Long, ByVal mBlend As Single, ByVal mPositions As Single, ByVal mCount As Long) As GpStatus
Private Declare Function GdipCreatePen2 Lib "GdiPlus.dll" (ByVal mBrush As Long, ByVal mWidth As Single, ByVal mUnit As GpUnit, ByRef mPen As Long) As GpStatus
Private Declare Function GdipCreateLineBrushI Lib "GdiPlus.dll" (ByRef mPoint1 As POINTL, ByRef mPoint2 As POINTL, ByVal mColor1 As Long, ByVal mColor2 As Long, ByRef mWrapMode As WrapMode, ByRef mLineGradient As Long) As GpStatus
Private Declare Function GdipFillPolygonI Lib "GdiPlus.dll" (ByVal mGraphics As Long, ByVal mBrush As Long, ByRef mPoints As POINTL, ByVal mCount As Long, ByVal mFillMode As FillMode) As GpStatus
Private Declare Function GdipSetSmoothingMode Lib "GdiPlus.dll" (ByVal mGraphics As Long, ByVal mSmoothingMode As SmoothingMode) As GpStatus

Private Declare Function GdipCreatePath Lib "GdiPlus.dll" (ByRef mBrushMode As FillMode, ByRef mpath As Long) As GpStatus
Private Declare Function GdipAddPathArcI Lib "GdiPlus.dll" (ByVal mpath As Long, ByVal mX As Long, ByVal mY As Long, ByVal mWidth As Long, ByVal mHeight As Long, ByVal mStartAngle As Single, ByVal mSweepAngle As Single) As GpStatus
Private Declare Function GdipDeletePath Lib "GdiPlus.dll" (ByVal mpath As Long) As GpStatus
Private Declare Function GdipFillPath Lib "GdiPlus.dll" (ByVal mGraphics As Long, ByVal mBrush As Long, ByVal mpath As Long) As GpStatus
Private Declare Function GdipAddPathLineI Lib "GdiPlus.dll" (ByVal mpath As Long, ByVal mX1 As Long, ByVal mY1 As Long, ByVal mX2 As Long, ByVal mY2 As Long) As GpStatus
Private Declare Function GdipDrawArcI Lib "GdiPlus.dll" (ByVal mGraphics As Long, ByVal mPen As Long, ByVal mX As Long, ByVal mY As Long, ByVal mWidth As Long, ByVal mHeight As Long, ByVal mStartAngle As Single, ByVal mSweepAngle As Single) As GpStatus

Private Declare Function CreateDIBSection Lib "gdi32.dll" (ByVal hdc As Long, ByRef pBitmapInfo As BITMAPINFOHEADER, ByVal un As Long, ByVal lplpVoid As Long, ByVal handle As Long, ByVal dw As Long) As Long
Private Const DIB_RGB_COLORS As Long = 0
Private Const BI_RGB         As Long = 0&
Private Type BITMAPINFOHEADER
    biSize          As Long
    biWidth         As Long
    biHeight        As Long
    biPlanes        As Integer
    biBitCount      As Integer
    biCompression   As Long
    biSizeImage     As Long
    biXPelsPerMeter As Long
    biYPelsPerMeter As Long
    biClrUsed       As Long
    biClrImportant  As Long
End Type

Public Declare Function GdipBitmapLockBits Lib "GdiPlus.dll" (ByVal mBitmap As Long, ByRef mRect As RECTL, ByVal mFlags As ImageLockMode, ByVal mPixelFormat As Long, ByRef mLockedBitmapData As BitmapData) As GpStatus
Public Declare Function GdipBitmapUnlockBits Lib "GdiPlus.dll" (ByVal mBitmap As Long, ByRef mLockedBitmapData As BitmapData) As GpStatus
Public Type BitmapData
    Width       As Long
    Height      As Long
    Stride      As Long
    PixelFormat As Long
    Scan0Ptr    As Long
    ReservedPtr As Long
End Type
Public Type RECTL
    Left   As Long
    Top    As Long
    Width  As Long
    Height As Long
End Type

Public Enum ImageLockMode
    ImageLockModeRead = &H1
    ImageLockModeWrite = &H2
    ImageLockModeUserInputBuf = &H4
End Enum

Public Enum EPixelFormat
    PixelFormat1bppIndexed = 196865
    PixelFormat4bppIndexed = 197634
    PixelFormat8bppIndexed = 198659
    PixelFormat16bppGrayScale = 1052676
    PixelFormat16bppRGB555 = 135173
    PixelFormat16bppRGB565 = 135174
    PixelFormat16bppARGB1555 = 397319
    PixelFormat24bppRGB = 137224
    PixelFormat32bppRGB = 139273
    PixelFormat32bppARGB = 2498570
    PixelFormat32bppPARGB = 925707
    PixelFormat48bppRGB = 1060876
    PixelFormat64bppARGB = 3424269
    PixelFormat64bppPARGB = 1851406
    PixelFormatMax = 15
End Enum

Public Type DRAWITEMSTRUCT
    CtlType    As Long
    CtlID      As Long
    itemID     As Long
    itemAction As Long
    itemState  As Long
    hwndItem   As Long
    hdc        As Long
    rcItem     As RECT
    itemData   As Long
End Type

Private Declare Function GetObjectAPI Lib "gdi32.dll" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, ByRef lpObject As Any) As Long
Private Type BITMAP
    bmType       As Long
    bmWidth      As Long
    bmHeight     As Long
    bmWidthBytes As Long
    bmPlanes     As Integer
    bmBitsPixel  As Integer
    bmBits       As Long
End Type

Private Declare Function GetDeviceCaps Lib "gdi32.dll" (ByVal hdc As Long, ByVal nIndex As Long) As Long
Private Const HORZRES As Long = 8
Private Const VERTRES As Long = 10

Private Declare Function GdipCreateBitmapFromGdiDib Lib "GdiPlus.dll" (ByRef mGdiBitmapInfo As BITMAPINFOHEADER, ByVal mgdiBitmapData As Long, ByRef mBitmap As Long) As GpStatus
Private Declare Function GdipCreateBitmapFromHBITMAP Lib "GdiPlus.dll" (ByVal mHbm As Long, ByVal mhPal As Long, ByRef mBitmap As Long) As GpStatus
'Private Declare Function GetDIBits Lib "gdi32.dll" (ByVal aHDC As Long, ByVal hBitmap As Long, ByVal nStartScan As Long, ByVal nNumScans As Long, ByRef lpBits As Any, ByRef lpBI As BITMAPINFO, ByVal wUsage As Long) As Long

Public Declare Function DeleteObject Lib "gdi32.dll" (ByVal hObject As Long) As Long
Public Declare Function CreateCompatibleDC Lib "gdi32.dll" (ByVal hdc As Long) As Long
Public Declare Function SelectObject Lib "gdi32.dll" (ByVal hdc As Long, ByVal hObject As Long) As Long
Public Declare Function DeleteDC Lib "gdi32.dll" (ByVal hdc As Long) As Long
Private Declare Function CreateCompatibleBitmap Lib "gdi32.dll" (ByVal hdc As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long

Public Declare Function GdipCreateBitmapFromScan0 Lib "GdiPlus.dll" (ByVal mWidth As Long, ByVal mHeight As Long, ByVal mStride As Long, ByVal mPixelFormat As Long, ByVal mScan0 As Long, ByRef mBitmap As Long) As GpStatus
Public Declare Function TransparentBlt Lib "msimg32.dll" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal crTransparent As Long) As Long
Private Declare Function GdipGetImageGraphicsContext Lib "GdiPlus.dll" (ByVal mImage As Long, ByRef mGraphics As Long) As GpStatus
Public Declare Function GdipCloneBitmapArea Lib "GdiPlus.dll" (ByVal mX As Single, ByVal mY As Single, ByVal mWidth As Single, ByVal mHeight As Single, ByVal mPixelFormat As Long, ByVal mSrcBitmap As Long, ByRef mDstBitmap As Long) As GpStatus
Public Declare Function GdipImageRotateFlip Lib "GdiPlus.dll" (ByVal mImage As Long, ByVal mRfType As RotateFlipType) As GpStatus
Public Enum RotateFlipType
    RotateNoneFlipNone = &H0
    Rotate90FlipNone = &H1
    Rotate180FlipNone = &H2
    Rotate270FlipNone = &H3
    RotateNoneFlipX = &H4
    Rotate90FlipX = &H5
    Rotate180FlipX = &H6
    Rotate270FlipX = &H7
    RotateNoneFlipY = &H6
    Rotate90FlipY = &H7
    Rotate180FlipY = &H4
    Rotate270FlipY = &H5
    RotateNoneFlipXY = &H2
    Rotate90FlipXY = &H3
    Rotate180FlipXY = &H0
    Rotate270FlipXY = &H1
End Enum

Public Enum SmoothingMode
    SmoothingModeInvalid = &HFFFFFFFF
    SmoothingModeDefault = &H0
    SmoothingModeHighSpeed = &H1
    SmoothingModeHighQuality = &H2
    SmoothingModeNone = &H3
    SmoothingModeAntiAlias = &H4
End Enum

Private Enum FillMode
    FillModeAlternate = &H0
    FillModeWinding = &H1
End Enum

Private Enum WrapMode
    WrapModeTile = &H0
    WrapModeTileFlipX = &H1
    WrapModeTileFlipy = &H2
    WrapModeTileFlipXY = &H3
    WrapModeClamp = &H4
End Enum

Public Enum PenAlignment
    PenAlignmentCenter = &H0
    PenAlignmentInset = &H1
End Enum

Public Enum PenType
    PenTypeSolidColor = &H0
    PenTypeHatchFill = &H1
    PenTypeTextureFill = &H2
    PenTypePathGradient = &H3
    PenTypeLinearGradient = &H4
    PenTypeUnknown = &HFFFFFFFF
End Enum

Public Enum LineCap
    LineCapFlat = &H0
    LineCapSquare = &H1
    LineCapRound = &H2
    LineCapTriangle = &H3
    LineCapNoAnchor = &H10
    LineCapSquareAnchor = &H11
    LineCapRoundAnchor = &H12
    LineCapDiamondAnchor = &H13
    LineCapArrowAnchor = &H14
    LineCapCustom = &HFF
    LineCapAnchorMask = &HF0
End Enum

Private Declare Function GdipGetImageEncoders Lib "GdiPlus.dll" (ByVal mNumEncoders As Long, ByVal msize As Long, ByRef mEncoders As Any) As GpStatus
Private Declare Function GdipGetImageEncodersSize Lib "GdiPlus.dll" (ByRef mNumEncoders As Long, ByRef msize As Long) As GpStatus
Private Type ImageCodecInfo
    CLSID(0 To 3)        As Long
    FormatID(0 To 3)     As Long
    CodecNamePtr         As Long
    DllNamePtr           As Long
    FormatDescriptionPtr As Long
    FilenameExtensionPtr As Long
    MimeTypePtr          As Long
    Flags                As Long ' ImageCodecFlags
    Version              As Long
    SigCount             As Long
    SigSize              As Long
    SigPatternPtr        As Long
    SigMaskPtr           As Long
End Type

Private Declare Function FindResource Lib "kernel32.dll" Alias "FindResourceA" (ByVal hInstance As Long, ByVal lpName As String, ByVal lpType As String) As Long
Private Declare Function LoadResource Lib "kernel32.dll" (ByVal hInstance As Long, ByVal hResInfo As Long) As Long
Private Declare Function LockResource Lib "kernel32.dll" (ByVal hResData As Long) As Long
Private Declare Function SizeofResource Lib "kernel32.dll" (ByVal hInstance As Long, ByVal hResInfo As Long) As Long

Private Declare Function GdipDrawCurveI Lib "GdiPlus.dll" (ByVal mGraphics As Long, ByVal mPen As Long, ByRef mPoints As POINTL, ByVal mCount As Long) As GpStatus
Private Declare Function GdipDrawClosedCurveI Lib "GdiPlus.dll" (ByVal mGraphics As Long, ByVal mPen As Long, ByRef mPoints As POINTL, ByVal mCount As Long) As GpStatus
Private Declare Function GdipSetPenLineJoin Lib "GdiPlus.dll" (ByVal mPen As Long, ByVal mLineJoin As LineJoin) As GpStatus
Private Declare Function GdipCreateRegionRectI Lib "GdiPlus.dll" (ByRef mRect As RECTL, ByRef mRegion As Long) As GpStatus
Private Declare Function GdipCombineRegionRectI Lib "GdiPlus.dll" (ByVal mRegion As Long, ByRef mRect As RECTL, ByRef mCombineMode As CombineMode) As GpStatus
Private Declare Function GdipCombineRegionPath Lib "GdiPlus.dll" (ByVal mRegion As Long, ByVal mpath As Long, ByVal mCombineMode As CombineMode) As GpStatus
Private Declare Function GdipDeleteRegion Lib "GdiPlus.dll" (ByVal mRegion As Long) As GpStatus
Private Declare Function GdipDrawPath Lib "GdiPlus.dll" (ByVal mGraphics As Long, ByVal mPen As Long, ByVal mpath As Long) As GpStatus
Private Declare Function GdipSetClipRegion Lib "GdiPlus.dll" (ByVal mGraphics As Long, ByVal mRegion As Long, ByVal mCombineMode As CombineMode) As GpStatus
Private Declare Function GdipResetClip Lib "GdiPlus.dll" (ByVal mGraphics As Long) As GpStatus
Private Declare Function GdipAddPathCurve2I Lib "GdiPlus.dll" (ByVal mpath As Long, ByRef mPoints As POINTL, ByVal mCount As Long, ByVal mTension As Single) As GpStatus
Private Declare Function GdipFillRegion Lib "GdiPlus.dll" (ByVal mGraphics As Long, ByVal mBrush As Long, ByVal mRegion As Long) As GpStatus
Private Declare Function GdipClosePathFigure Lib "GdiPlus.dll" (ByVal mpath As Long) As GpStatus
Private Declare Function GdipAddPathRectangleI Lib "GdiPlus.dll" (ByVal mpath As Long, ByVal mX As Long, ByVal mY As Long, ByVal mWidth As Long, ByVal mHeight As Long) As GpStatus
Private Enum CombineMode
    CombineModeReplace = &H0
    CombineModeIntersect = &H1
    CombineModeUnion = &H2
    CombineModeXor = &H3
    CombineModeExclude = &H4
    CombineModeComplement = &H5
End Enum
Private Enum LineJoin
    LineJoinMiter = &H0
    LineJoinBevel = &H1
    LineJoinRound = &H2
    LineJoinMiterClipped = &H3
End Enum

Private Declare Function GetDC Lib "user32.dll" (ByVal hWnd As Long) As Long

Private m_hGDIPToken As Long


Public Function initializeGDIPlus() As Boolean
Attribute initializeGDIPlus.VB_Description = "Initialize GDIPlus. Called by X3Button sub Main()"
    Dim bRet As Boolean, tGDIPSI As GdiplusStartupInput
    
    If (m_hGDIPToken = 0) Then
        tGDIPSI.GdiplusVersion = 1
        Call GdiplusStartup(m_hGDIPToken, tGDIPSI, ByVal 0)
    End If
    
    initializeGDIPlus = (m_hGDIPToken <> 0)
End Function

Public Function shutdownGDIPlus()
    If (m_hGDIPToken <> 0) Then
        Call GdiplusShutdown(m_hGDIPToken)
        m_hGDIPToken = 0
    End If
End Function

Public Function getGDIPlusToken() As Long
    getGDIPlusToken = m_hGDIPToken
End Function

Public Function loadImage(ByRef szPath As String, ByRef hImg As Long, Optional ByRef bFromRes As Boolean = False) As Boolean
    If (IsTextUnicode(ByVal szPath, Len(szPath), ByVal 0) = 0) Then
        szPath = StrConv(szPath, vbUnicode)
    End If
    
    If (bFromRes) Then
        Call GdipCreateBitmapFromResource(App.hInstance, szPath, hImg)
    Else
        Call GdipCreateBitmapFromFile(szPath, hImg)
    End If
    
    loadImage = (hImg <> 0)
End Function

Public Function deleteImage(ByRef hImg As Long) As Boolean
    Dim eRet As GpStatus
    
    If (hImg) Then eRet = GdipDisposeImage(hImg): hImg = 0
    deleteImage = (eRet = GpStatus.Ok)
End Function

Public Function drawXPThemeButtonL(ByRef hGraphics As Long, ByRef hImgBtn As Long, ByVal eState As EPushButtonState, ByVal lX1 As Long, ByVal lY1 As Long, ByVal lX2 As Long, ByVal lY2 As Long, Optional ByVal bOpacity As Byte = 255, Optional ByVal sBrightness As Single = 1, Optional ByVal sRIntensity As Single = 1, Optional ByVal sGIntensity As Single = 1, Optional ByVal sBIntensity As Single = 1) As Boolean
    Dim rcBtnArea As RECT, lAttr As Long, tColMatrix As ColorMatrix, tGreyMatrix As ColorMatrix, bOK As Boolean, eRet As GpStatus
    
    bOK = False
    If (hImgBtn) Then
        With rcBtnArea
            .Left = lX1
            .Top = lY1
            .Right = lX2
            .Bottom = lY2
        End With
        
        '--See X3BIcon
        With tColMatrix
            .m(0, 0) = (sRIntensity * sBrightness)
            .m(1, 1) = (sGIntensity * sBrightness)
            .m(2, 2) = (sBIntensity * sBrightness)
            .m(3, 3) = (bOpacity / 255)
            
            .m(4, 0) = 1
            .m(4, 1) = 1
            .m(4, 2) = 1
            .m(4, 3) = 0
            
            .m(4, 4) = 1
        End With
        
        eRet = GdipCreateImageAttributes(lAttr)
        eRet = GdipSetImageAttributesColorMatrix(lAttr, ColorAdjustTypeBitmap, 1, tColMatrix, tGreyMatrix, ColorMatrixFlagsDefault)
        bOK = drawXPThemeButton(hGraphics, hImgBtn, eState, rcBtnArea, lAttr)
        eRet = GdipDisposeImageAttributes(lAttr)
    End If
    drawXPThemeButtonL = bOK
End Function

Private Function drawXPThemeButton(ByRef hGraphics As Long, ByRef hImgBtn As Long, ByVal eState As EPushButtonState, ByRef rcBtnArea As RECT, Optional ByVal lAttr As Long = 0) As Boolean
    Dim sY As Long, sW As Single, sH As Single, bOK As Boolean
    
    bOK = False
    If ((hImgBtn) And (GdipGetImageDimension(hImgBtn, sW, sH) = Ok)) Then
        sH = (sH \ 5)
        sY = (eState * sH)
        
        '--To draw XP Button resources, each corner is a (4,4) rect with the center (5,5)-(Wid-10,Hei-10)
        '--Each resource image has 5 parts: NORMAL(0), HOT(1), PRESSED(2), DISABLED(3), FOCUS(4)
        '--Each image can be obtained via:
        '--ButtonH = (ImageHeight \ 5)
        '--ButtonY = (StateIndex * ButtonHeight)
        '--For precision reasons, the image height should be evenly divisible by 5
        With rcBtnArea
            Call GdipDrawImageRectRectI(hGraphics, hImgBtn, .Left, .Top, 4, 4, 1, (sY + 1), 4, 4, UnitPixel, ByVal lAttr, ByVal 0, ByVal 0)
            Call GdipDrawImageRectRectI(hGraphics, hImgBtn, (.Right - 4), .Top, 4, 4, (sW - 5), (sY + 1), 4, 4, UnitPixel, ByVal lAttr, ByVal 0, ByVal 0)
            Call GdipDrawImageRectRectI(hGraphics, hImgBtn, (.Right - 4), (.Bottom - 4), 4, 4, (sW - 5), (sY + sH - 5), 4, 4, UnitPixel, ByVal lAttr, ByVal 0, ByVal 0)
            Call GdipDrawImageRectRectI(hGraphics, hImgBtn, .Left, (.Bottom - 4), 4, 4, 1, (sY + sH - 5), 4, 4, UnitPixel, ByVal lAttr, ByVal 0, ByVal 0)
            
            Call GdipDrawImageRectRectI(hGraphics, hImgBtn, .Left, (.Top + 4), 4, (.Bottom - .Top - 8), 1, (sY + 5), 4, (sH - 10), UnitPixel, ByVal lAttr, ByVal 0, ByVal 0)
            Call GdipDrawImageRectRectI(hGraphics, hImgBtn, (.Left + 4), .Top, (.Right - .Left - 8), 4, 5, (sY + 1), (sW - 10), 4, UnitPixel, ByVal lAttr, ByVal 0, ByVal 0)
            Call GdipDrawImageRectRectI(hGraphics, hImgBtn, (.Right - 4), (.Top + 4), 4, (.Bottom - .Top - 8), (sW - 5), (sY + 5), 4, (sH - 10), UnitPixel, ByVal lAttr, ByVal 0, ByVal 0)
            Call GdipDrawImageRectRectI(hGraphics, hImgBtn, (.Left + 4), (.Bottom - 4), (.Right - .Left - 8), 4, 5, (sY + sH - 5), (sW - 10), 4, UnitPixel, ByVal lAttr, ByVal 0, ByVal 0)
    
            Call GdipDrawImageRectRectI(hGraphics, hImgBtn, (.Left + 4), (.Top + 4), (.Right - .Left - 8), (.Bottom - .Top - 8), 5, (sY + 5), (sW - 10), (sH - 10), UnitPixel, ByVal lAttr, ByVal 0, ByVal 0)
        End With
        bOK = True
    End If
    
    drawXPThemeButton = bOK
End Function

Public Function getBorderColor(ByVal hImg As Long, ByRef lCol As Long) As Boolean
    Dim i As Integer, sW As Single, sH As Single, szHex As String
    
    '--Get the border color of the XPButton resource image strip by doing a top-down scan of the pixels
    '--The first pixel that's not completely transparent, (i.e. Alpha > 0) will be used as the border color
    '--If none is found, the default color is black
    If (GdipGetImageDimension(hImg, sW, sH) = Ok) Then
        sH = (sH / 5)
        lCol = 0
        For i = 0 To (sH - 1) Step 1
            Call GdipBitmapGetPixel(hImg, (sW \ 2), i, lCol)
            szHex = Right("0000000" + Hex(lCol), 8)
            If (Left(szHex, 2) <> "00") Then Exit For
        Next i
        If (lCol = 0) Then lCol = &HFF000000
        getBorderColor = True
    Else
        getBorderColor = False
    End If
End Function

Public Function drawLine(ByVal hGraphics As Long, ByVal lX1 As Long, ByVal lY1 As Long, ByVal lX2 As Long, _
                         ByVal lY2 As Long, Optional ByVal nWid As Integer = 1, Optional ByRef lCol32A As Long = &HFFFFFFFF, _
                         Optional ByRef vCol32B As Variant = Empty, Optional ByRef ePenAlignment As PenAlignment = PenAlignment.PenAlignmentCenter, _
                         Optional ByRef eCap As LineCap = LineCap.LineCapFlat)
    Dim hPen As Long, hBrush As Long, eRet As GpStatus, ptArr() As POINTL
    
    If (Not IsEmpty(vCol32B)) Then
        ReDim ptArr(1)
        With ptArr(0)
            .x = lX1
            .y = lY1
        End With
        With ptArr(1)
            .x = lX2
            .y = lY2
        End With
        '--Create a LineBrush aka a gradient based on the 2 colors
        Call GdipCreateLineBrushI(ptArr(0), ptArr(1), lCol32A, CLng(vCol32B), WrapModeTile, hBrush)
        '--Create a pen based on that gradient
        eRet = GdipCreatePen2(hBrush, nWid, UnitPixel, hPen)
    Else
        '--Create a single color pen
        eRet = GdipCreatePen1(lCol32A, nWid, UnitPixel, hPen)
    End If
    If (eRet = Ok) Then
        Call GdipSetPenStartCap(hPen, eCap)
        Call GdipSetPenEndCap(hPen, eCap)
        Call GdipSetPenMode(hPen, ePenAlignment)
        Call GdipDrawLineI(hGraphics, hPen, lX1, lY1, lX2, lY2)
        Call GdipDeletePen(hPen)
    End If
    If (hBrush) Then Call GdipDeleteBrush(hBrush)
End Function

Public Function drawRectFrame(ByVal hGraphics As Long, ByVal lX As Long, ByVal lY As Long, ByVal lW As Long, ByVal lH As Long, ByVal lCol32 As Long, ByVal nWid As Integer)
    Call drawLine(hGraphics, lX, lY, (lX + lW), lY, nWid, lCol32)
    Call drawLine(hGraphics, lX, lY, lX, (lY + lH), nWid, lCol32)
    Call drawLine(hGraphics, lX, (lY + lH), (lX + lW), (lY + lH), nWid, lCol32)
    Call drawLine(hGraphics, (lX + lW), lY, (lX + lW), (lY + lH), nWid, lCol32)
End Function

Public Function drawArrow(ByVal hGraphics As Long, ByVal lCenterX As Long, ByVal lCenterY As Long, ByVal lCol32 As Long, ByVal eDir As Integer)
    Dim ptArr(2) As POINTL, hBrush As Long
    
    Select Case eDir
        Case AD_UP, AD_DOWN
            With ptArr(0)
                .x = lCenterX - 4
                .y = lCenterY
            End With
            With ptArr(1)
                .x = lCenterX + 4
                .y = lCenterY
            End With
            With ptArr(2)
                .x = lCenterX
                .y = lCenterY + IIf((eDir = AD_UP), -5, 5)
            End With
            
        Case AD_LEFT, AD_RIGHT
            With ptArr(0)
                .x = lCenterX - 1
                .y = lCenterY - 5
            End With
            With ptArr(1)
                .x = lCenterX - 1
                .y = lCenterY + 5
            End With
            With ptArr(2)
                .x = lCenterX + IIf((eDir = AD_LEFT), -4, 4)
                .y = lCenterY
            End With
    End Select

    Call GdipCreateSolidFill(lCol32, hBrush)
    Call GdipFillPolygonI(hGraphics, hBrush, ptArr(0), 3, FillModeAlternate)
    Call GdipDeleteBrush(hBrush)
End Function

Public Function getGraphicsContext(ByVal hDCTarget As Long) As Long
    Dim hGraphics As Long, eRet As GpStatus
    
    '--Create a Graphics Contenxt based on the HDC hDCTarget
    eRet = GdipCreateFromHDC(hDCTarget, hGraphics)
    getGraphicsContext = hGraphics
End Function

Public Function deleteGraphicsContext(ByVal hGraphics As Long)
    If (hGraphics) Then
        Call GdipDeleteGraphics(hGraphics)
        hGraphics = 0
    End If
End Function

Public Function setAAGraphicsSmoothingMode(ByVal hGraphics As Long)
    '--Anti-aliased shapes, paths, lines, etc...
    Call GdipSetSmoothingMode(hGraphics, SmoothingModeAntiAlias)
    '--HQ clear type text
    Call GdipSetTextRenderingHint(hGraphics, TextRenderingHintAntiAlias)
    '--HQ image resizing and coposition
    Call GdipSetCompositingQuality(hGraphics, CompositingQualityHighQuality)
    Call GdipSetInterpolationMode(hGraphics, InterpolationModeHighQualityBicubic)
End Function

Public Function getParentBackColor(ByVal ctlParent As Object) As Long
    On Error GoTo EH
    
    '--Return the parent back color in ARGB format
    getParentBackColor = convertColorStructure(ctlParent.BackColor, [ColorRef To Color32])
    Exit Function
EH:
    getParentBackColor = convertColorStructure(SystemColorConstants.vbButtonFace, [ColorRef To Color32])
End Function

Public Function blitParentBackground(ByVal hWndChild As Long, ByVal hDCDest As Long, ByVal hDCSrc As Long) As Boolean
    Dim rcWndChild As RECT, ptChildTL As POINTAPI, ptParentTL As POINTAPI, hwndParent As Long
    
    '--Copy the parent background from the parent DC onto the destination DC
    '--Get the parent and child window positions relative to the screen by translating the top-left positions of each window
    '--Get the parent top-left as well so we can clip off the border width and height
    ptChildTL.x = 0: ptChildTL.y = 0
    ptParentTL.x = 0: ptParentTL.y = 0
    hwndParent = GetParent(hWndChild)
    Call ClientToScreen(hwndParent, ptParentTL)
    Call ClientToScreen(hWndChild, ptChildTL)
    '--Get the dimensions of the child window
    Call GetWindowRect(hWndChild, rcWndChild)
    Call OffsetRect(rcWndChild, -(ptParentTL.x), -(ptParentTL.y))
    With rcWndChild
        '--Copy the parent background to the cdestination DC
        blitParentBackground = (BitBlt(hDCDest, 0, 0, (.Right - .Left), (.Bottom - .Top), hDCSrc, .Left, .Top, SRCCOPY) <> 0)
    End With
End Function

Public Function fillRectGDIP(ByVal hGraphics As Long, ByVal lCol32 As Long, ByVal lX As Long, ByVal lY As Long, ByVal lW As Long, ByVal lH As Long, _
                             Optional ByVal lOutlineCol As Long = 0, Optional ByVal lOutlineWid As Long = 1, _
                             Optional ByVal lCol32B As Long = 0, Optional ByVal bHorzGradnt As Boolean = False, _
                             Optional ByVal bRound As Boolean = False, Optional ByVal lArcWid As Long = 6, Optional ByVal lArcHei As Long = 6)
    Dim hBrush As Long, hPath As Long, lX2 As Long, lY2 As Long, hPen As Long, ptArr() As POINTL, hRgn As Long, hBrushOutline As Long
    
    '--As far as i see, GDIPlus fills the inside of the rect with the specified brush
    '--So, -1 from X & Y and add 2 to W & H
    lX = (lX - 1)
    lY = (lY - 1)
    lW = (lW + 2)
    lH = (lH + 2)
    lX2 = (lX + lW)
    lY2 = (lY + lH)
    
    '--Create either a solid color brush or a gradient one
    If (lCol32B = 0) Then
        Call GdipCreateSolidFill(lCol32, hBrush)
    Else
        '--Horizontal Gradient (X1,Y1) - (X2,Y1)
        '--Vertical Gradient   (X1,Y1) - (X1,Y2)
        ReDim ptArr(1)
        With ptArr(0)
            .x = lX
            .y = lY
        End With
        With ptArr(1)
            .x = IIf((bHorzGradnt), lX2, lX) + IIf((bRound), lArcWid * 2, 0) + 2
            .y = IIf((bHorzGradnt), lY, lY2) + IIf((bRound), lArcHei * 2, 0) + 2
        End With
        '--Create the gradient
        Call GdipCreateLineBrushI(ptArr(0), ptArr(1), lCol32, lCol32B, ByVal WrapModeTile, hBrush)
    End If

    If (Not bRound) Then
        If (lOutlineCol) Then
            Call GdipCreatePen1(lOutlineCol, lOutlineWid, UnitPixel, hPen)
            Call GdipSetPenLineJoin(hPen, LineJoinBevel)
            Call GdipSetPenMode(hPen, PenAlignmentInset)
            
            Call GdipCreatePath(FillModeWinding, hPath)
            Call GdipAddPathRectangleI(hPath, lX, lY, lW, lH)
            Call GdipClosePathFigure(hPath)
            
            Call GdipDrawPath(hGraphics, hPen, hPath)
            Call GdipDeletePen(hPen)
            Call GdipDeletePath(hPath)
            Call GdipFillRectangleI(hGraphics, hBrush, (lX + lOutlineWid) - 1, (lY + lOutlineWid) - 1, lW - (lOutlineWid * 2) + 2, lH - (lOutlineWid * 2) + 2)
        Else
            Call GdipFillRectangleI(hGraphics, hBrush, lX, lY, lW, lH)
        End If
    Else
        Call GdipCreatePath(FillModeWinding, hPath)
        Call GdipAddPathArcI(hPath, lX, lY, lArcWid, lArcHei, 180, 90)
        Call GdipAddPathArcI(hPath, lX2 - (lOutlineWid * 2) - 1, lY, lArcWid, lArcHei, 270, 90)
        Call GdipAddPathArcI(hPath, lX2 - (lOutlineWid * 2) - 1, lY2 - (lOutlineWid * 2) - 1, lArcWid, lArcHei, 0, 90)
        Call GdipAddPathArcI(hPath, lX, lY2 - (lOutlineWid * 2) - 1, lArcWid, lArcHei, 90, 90)
        Call GdipClosePathFigure(hPath)
        Call GdipFillPath(hGraphics, hBrush, hPath)
        
        If (lOutlineCol) Then
            Call GdipCreatePen1(lOutlineCol, lOutlineWid, UnitPixel, hPen)
            Call GdipSetPenLineJoin(hPen, LineJoinRound)
            Call GdipSetPenEndCap(hPen, LineCapRound)
            Call GdipSetPenStartCap(hPen, LineCapRound)
            Call GdipSetPenMode(hPen, PenAlignmentCenter)
            
            Call GdipDrawPath(hGraphics, hPen, hPath)
            Call GdipDeletePen(hPen)
        End If
        Call GdipDeletePath(hPath)
    End If
    
    Call GdipDeleteBrush(hBrush)
End Function

Public Function fillRectGDI(ByVal hDCTarget As Long, ByVal lColRef As Long, ByVal lX As Long, ByVal lY As Long, ByVal lW As Long, ByVal lH As Long)
    Dim hBrush As Long, rcArea As RECT
    
    Call OleTranslateColor(lColRef, 0, lColRef)
    hBrush = CreateSolidBrush(lColRef)
    Call SetRect(rcArea, lX, lY, (lX + lW), (lY + lH))
    Call FillRect(hDCTarget, rcArea, hBrush)
    Call DeleteObject(hBrush)
End Function

Public Function mouseOverControl(ByRef hWnd As Long) As Boolean
    Dim ptCur As POINTAPI, rcCtrl As RECT
    
    Call GetCursorPos(ptCur)
    Call GetWindowRect(hWnd, rcCtrl)
    mouseOverControl = (PtInRect(rcCtrl, ptCur.x, ptCur.y) = 1)
End Function

Public Function convertColorStructure(ByVal lCol As Long, ByRef eMode As EConversionMode) As Long
    Dim bColCompArr(3) As Byte, szHex As String, lNewCol As Long

    If (eMode = [ColorRef To Color32]) Then
        Call OleTranslateColor(lCol, 0, lCol)
    End If
    
    szHex = Right("00000000" + Hex(lCol), 8)
    If (eMode = [ColorRef To Color32]) Then  '00BBGGRR -> AARRGGBB
        lNewCol = CLng("&HFF" + Mid(szHex, 7, 2) + Mid(szHex, 5, 2) + Mid(szHex, 3, 2))
    Else                                     'AARRGGBB -> 00BBGGRR
        lNewCol = CLng("&H00" + Mid(szHex, 7, 2) + Mid(szHex, 5, 2) + Mid(szHex, 3, 2))
    End If
    
    convertColorStructure = lNewCol
End Function

Public Function getRelativeCursorPosition(ByRef lX As Long, ByRef lY As Long, ByVal hWnd As Long)
    Dim ptCur As POINTAPI
    
    Call GetCursorPos(ptCur)
    Call ScreenToClient(hWnd, ptCur)
    
    lX = ptCur.x
    lY = ptCur.y
End Function

Public Function splitDWORD(ByRef dwVal As Long, ByRef nLW As Integer, ByRef nHW As Integer)
    Call CopyMemory(nLW, dwVal, 2)
    Call CopyMemory(nHW, ByVal VarPtr(dwVal) + 2, 2)
End Function

Public Function splitDWORDEx(ByRef dwVal As Long, ByRef bLWLB As Byte, ByRef bLWHB As Byte, ByRef bHWLB As Byte, ByRef bHWHB As Byte)
    Call CopyMemory(bLWLB, ByVal VarPtr(dwVal) + 0, 1)
    Call CopyMemory(bLWHB, ByVal VarPtr(dwVal) + 1, 1)
    Call CopyMemory(bHWLB, ByVal VarPtr(dwVal) + 2, 1)
    Call CopyMemory(bHWHB, ByVal VarPtr(dwVal) + 3, 1)
End Function

Public Function makeDWORD(ByRef dwVal As Long, ByRef nLW As Integer, ByRef nHW As Integer)
    Call CopyMemory(dwVal, nLW, 2)
    Call CopyMemory(ByVal VarPtr(dwVal) + 2, nHW, 2)
End Function

Public Function makeForegroundWindow(ByVal hWndNewFG As Long)
    Dim lForeThreadID  As Long, lhWndNewFGThreadID As Long, hWndFG As Long, bDetach As Boolean
    
    hWndFG = GetForegroundWindow()
    If (hWndFG = hWndNewFG) Then
        Call SetFocusAPI(hWndNewFG)
        Exit Function
    End If
    
    If (hWndFG) Then
        lForeThreadID = GetWindowThreadProcessId(hWndFG, ByVal 0)
        lhWndNewFGThreadID = GetWindowThreadProcessId(hWndNewFG, ByVal 0)
        If (lForeThreadID <> lhWndNewFGThreadID) Then
            bDetach = True
            'Attach the Foreground window thread to the thread of the new fg window so they share their input states,
            'and as such they have the same idea of the active window
            Call AttachThreadInput(lForeThreadID, lhWndNewFGThreadID, 1)
            Call SetForegroundWindow(hWndNewFG)
        Else
            Call SetForegroundWindow(hWndNewFG)
        End If
    Else
        Call SetForegroundWindow(hWndNewFG)
    End If
    
    Call SetFocusAPI(hWndNewFG)
    If (bDetach) Then Call AttachThreadInput(lForeThreadID, lhWndNewFGThreadID, 0)
End Function

Public Function getWindowDimensions(ByVal hWnd As Long, ByRef lX As Long, ByRef lY As Long, ByRef lW As Long, ByRef lH As Long)
    Dim rcWnd As RECT
    
    Call GetWindowRect(hWnd, rcWnd)
    lX = rcWnd.Left
    lY = rcWnd.Top
    lW = (rcWnd.Right - rcWnd.Left)
    lH = (rcWnd.Bottom - rcWnd.Top)
End Function

Public Function getTopLevelParent(ByVal hWnd As Long) As Long
    Do While (GetParent(hWnd) <> 0)
        hWnd = GetParent(hWnd)
    Loop
    getTopLevelParent = hWnd
End Function

Public Function translateOLEColor(ByVal lCol As Long) As Long
    Call OleTranslateColor(lCol, 0, lCol)
    translateOLEColor = lCol
End Function

Public Function getDWORDPaddedSize(ByVal lW As Long) As Long
    If ((lW Mod 4) = 0) Then getDWORDPaddedSize = lW Else getDWORDPaddedSize = lW + (4 - (lW Mod 4))
End Function

Public Function createDIB(ByVal lW As Long, ByVal lH As Long, ByVal nBpp As Integer, ByRef lpBits As Long) As Long
    Dim tBIH As BITMAPINFOHEADER
    
    With tBIH
        .biBitCount = nBpp
        .biCompression = BI_RGB
        .biHeight = lH
        .biPlanes = 1
        .biSize = Len(tBIH)
        .biWidth = lW
    End With
    
    createDIB = CreateDIBSection(0, tBIH, DIB_RGB_COLORS, VarPtr(lpBits), 0, 0)
    If ((lpBits) And (nBpp = 32)) Then Call ZeroMemory(ByVal lpBits, (lW * lH * 4))
End Function

Public Function createImage(ByVal lW As Long, ByVal lH As Long, ByVal ePF As EPixelFormat) As Long
    Call GdipCreateBitmapFromScan0(lW, lH, getDWORDPaddedSize(lW), CLng(ePF), 0, createImage)
End Function

Public Function createImageFromDIB(ByVal hDIB As Long) As Long
    Dim tBM As BITMAP, tBIH As BITMAPINFOHEADER, eRet As GpStatus, hImg As Long, hImgClone As Long, ePF As EPixelFormat
    
    If (GetObjectAPI(hDIB, Len(tBM), tBM)) Then
        With tBIH
            .biBitCount = tBM.bmBitsPixel
            .biCompression = BI_RGB
            .biHeight = tBM.bmHeight
            .biPlanes = 1
            .biSize = Len(tBIH)
            .biWidth = tBM.bmWidth
            .biSizeImage = (tBM.bmWidthBytes * tBM.bmHeight)
        End With
        
        Select Case tBM.bmBitsPixel
            Case 1:  ePF = PixelFormat1bppIndexed
            Case 8:  ePF = PixelFormat8bppIndexed
            Case 16: ePF = PixelFormat16bppRGB555
            Case 24: ePF = PixelFormat24bppRGB
            Case 32: ePF = PixelFormat32bppARGB
        End Select
        
        eRet = GdipCreateBitmapFromScan0(tBM.bmWidth, tBM.bmHeight, tBM.bmWidthBytes, ePF, tBM.bmBits, hImg)
        '--Duplicate the image so we can delete the source image
        eRet = GdipCloneBitmapArea(0, 0, tBM.bmWidth, tBM.bmHeight, ePF, hImg, hImgClone)
        eRet = GdipDisposeImage(hImg)
    End If
    createImageFromDIB = hImgClone
End Function

Public Function drawBmp(ByVal hBmp As Long, ByVal hDCDest As Long, ByVal lX As Long, ByVal lY As Long, Optional ByVal lW As Long = -1, Optional ByVal lH As Long = -1) As Long
    Dim hDCMem As Long, tBM As BITMAP, hBmpPrev As Long, lRet As Long
    
    lRet = 0
    If (GetObjectAPI(hBmp, Len(tBM), tBM)) Then
        If (lW = -1) Then lW = tBM.bmWidth
        If (lH = -1) Then lH = tBM.bmHeight
        hDCMem = CreateCompatibleDC(0)
        hBmpPrev = SelectObject(hDCMem, hBmp)
        lRet = BitBlt(hDCDest, lX, lY, lW, lH, hDCMem, 0, 0, SRCCOPY)
        Call SelectObject(hDCMem, hBmpPrev)
        Call DeleteDC(hDCMem)
    End If
    drawBmp = lRet
End Function

Public Function createStdPicFromDC(ByVal hDCSrc As Long, Optional ByVal lX As Long = -1, Optional ByVal lY As Long = -1, Optional ByVal lW As Long = -1, Optional ByVal lH As Long = -1) As StdPicture
    Dim hBmp As Long, hBmpPrev As Long, hDCMem As Long, lRet As Long
    
    If (lX = -1) Then lX = 0
    If (lY = -1) Then lY = 0
    If (lW = -1) Then lW = GetDeviceCaps(hDCSrc, HORZRES)
    If (lH = -1) Then lH = GetDeviceCaps(hDCSrc, VERTRES)
    
    hDCMem = CreateCompatibleDC(hDCSrc)
    hBmp = CreateCompatibleBitmap(hDCSrc, lW, lH)
    hBmpPrev = SelectObject(hDCMem, hBmp)
    lRet = BitBlt(hDCMem, 0, 0, lW, lH, hDCSrc, lX, lY, SRCCOPY)
    Call SelectObject(hDCMem, hBmpPrev)
    Call DeleteDC(hDCMem)
    
    Set createStdPicFromDC = convertBitmapToStdPicture(hBmp, PICTYPE.PICTYPE_BITMAP)
End Function
                         
Public Function getImageGraphicsContext(ByVal hImg As Long) As Long
    Call GdipGetImageGraphicsContext(hImg, getImageGraphicsContext)
End Function

Public Function getGraphicsContextDC(ByVal hGraphics As Long) As Long
    Call GdipGetDC(hGraphics, getGraphicsContextDC)
End Function

Public Function releaseGraphicsContextDC(ByVal hGraphics As Long, ByVal hdc As Long)
    Call GdipReleaseDC(hGraphics, hdc)
End Function

Public Function getCursorPosition(ByRef lX As Long, ByRef lY As Long, Optional ByVal hWndClient As Long = 0)
    Dim ptCur As POINTAPI
    
    Call GetCursorPos(ptCur)
    If (hWndClient) Then Call ScreenToClient(hWndClient, ptCur)
    lX = ptCur.x
    lY = ptCur.y
End Function

Public Function convertBitmapToStdPicture(ByVal hBmp As Long, ByVal lPicType As Long) As StdPicture
    Dim tIID As UUID, tPicDesc As PICTDESC, picIcon As StdPicture
    
    Set picIcon = Nothing
    If (hBmp) Then
        Call CLSIDFromString(IIDSTR_IDispatch, tIID)
        With tPicDesc
            .cbSizeofstruct = Len(tPicDesc)
            .hBitmap = hBmp
            .hpal_or_xExt = 0
            .PICTYPE = lPicType
            .yExt = 0
        End With
        Set picIcon = OleCreatePictureIndirect(tPicDesc, tIID, 1)
    End If
    Set convertBitmapToStdPicture = picIcon
End Function

Public Function ARGB(ByVal bA As Byte, ByVal bR As Byte, ByVal bG As Byte, ByVal bB As Byte)
    '--AARRGGBB
    ARGB = CLng("&H" + Right("0" + Hex(bA), 2) + Right("0" + Hex(bR), 2) + Right("0" + Hex(bG), 2) + Right("0" + Hex(bB), 2))
End Function

Public Function replaceByte(ByRef dwValue As Long, ByVal nByte As Integer, ByVal bVal As Byte)
    '--Replace a byte in a DWORD. nByte must be 0, 1, 2, or 3
    If ((nByte >= 0) And (nByte <= 3)) Then Call CopyMemory(ByVal VarPtr(dwValue) + nByte, bVal, 1)
End Function

Public Function getImageEncoderCLSID(ByRef szMimeType As String, ByVal lpBuff As Long) As Boolean
    Dim lEncCnt As Long, lEncSize As Long, tICI As ImageCodecInfo, bEncDataArr() As Byte, lIndx As Long
    
    '--Get image encoder by MIME type
    '--image/png, image/jpg, image/bmp, image/tiff, image/gif
    getImageEncoderCLSID = False
    Call GdipGetImageEncodersSize(lEncCnt, lEncSize)
    ReDim bEncDataArr(lEncSize - 1)
    Call GdipGetImageEncoders(lEncCnt, lEncSize, bEncDataArr(0))
    
    For lIndx = 0 To (lEncCnt - 1) Step 1
        Call CopyMemory(tICI, bEncDataArr(lIndx * Len(tICI)), Len(tICI))
        '--Do a case insensitive check of the current encoder mime type to that passed in
        If (StrComp(WideStr2BSTR(tICI.MimeTypePtr), szMimeType, vbTextCompare) = 0) Then
            Call CopyMemory(ByVal lpBuff, tICI.CLSID(0), 16)
            getImageEncoderCLSID = True
            Exit For
        End If
    Next lIndx
End Function

Public Function WideStr2BSTR(ByVal lpwStr As Long) As String
    Dim lLen As Long, wszData As String
    
    '--VB uses BSTR strings which is Unicode so just copy the data
    lLen = lstrlenW(ByVal lpwStr)
    If (lLen) Then
        wszData = String(lLen, vbNullChar)
        Call CopyMemory(ByVal StrPtr(wszData), ByVal lpwStr, (lLen * 2))
    End If
    WideStr2BSTR = wszData
End Function

Public Function resource2ByteArray(ByVal szName As String, ByRef szType As String, ByRef bDataArr() As Byte, Optional ByVal hInst As Long = 0) As Boolean
    Dim hResInfo As Long, hResData As String, lpResData As Long, lResSize As Long
    
    resource2ByteArray = False
    If (hInst = 0) Then hInst = App.hInstance
    hResInfo = FindResource(hInst, szName, szType)
    If (hResInfo) Then
        hResData = LoadResource(hInst, hResInfo)
        lResSize = SizeofResource(hInst, hResInfo)
        If ((lResSize) And (hResData)) Then
            '--Lock the resource to get a pointer to its data
            lpResData = LockResource(hResData)
            ReDim bDataArr(lResSize - 1)
            Call CopyMemory(bDataArr(0), ByVal lpResData, lResSize)
            resource2ByteArray = True
        End If
    End If
End Function

Public Function byteArray2Stream(ByRef bDataArr() As Byte) As IStream
    Dim pStream As IStream, lSize As Long
    
    Set pStream = Nothing
    If ((Not bDataArr) <> -1) Then
        '--Create a sizable stream on global mem
        Set pStream = CreateStreamOnHGlobal(ByVal 0, 1)
        lSize = UBound(bDataArr) + 1
        If ((Not pStream Is Nothing) And (lSize)) Then
            '--Copy the data from the byte array and seek back to the beginning of the stream for programmer sanity
            Call pStream.Write(bDataArr(0), lSize)
            Call pStream.Seek(0, STREAM_SEEK_SET)
        End If
    End If
    Set byteArray2Stream = pStream
End Function

Public Function stream2ByteArray(ByVal pStream As IStream, ByRef bDataArr() As Byte) As Boolean
    Dim tStreamInfo As STATSTG
    
    stream2ByteArray = False
    If (Not pStream Is Nothing) Then
        '--Get the size of the Stream
        Call pStream.Stat(tStreamInfo)
        '--Multiply by 10000 for int64
        tStreamInfo.cbSize = (tStreamInfo.cbSize * 10000)
        If (tStreamInfo.cbSize > 0) Then
            ReDim bDataArr(tStreamInfo.cbSize - 1)
            Call pStream.Seek(0, STREAM_SEEK.STREAM_SEEK_SET)
            '--Copy the data from the stream
            Call pStream.Read(bDataArr(0), tStreamInfo.cbSize)
            stream2ByteArray = True
        End If
    End If
End Function

Public Function getHANDCursor() As StdPicture
    Set getHANDCursor = convertBitmapToStdPicture(LoadCursor(0, ByVal IDC_HAND), PICTYPE_ICON)
End Function

















