Attribute VB_Name = "mWndProc"
Option Explicit

Private Declare Function GetWindowLong Lib "user32.dll" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Private Declare Function SetWindowLong Lib "user32.dll" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function CallWindowProc Lib "user32.dll" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Const GWL_WNDPROC As Long = -4

Private Declare Function SetProp Lib "user32.dll" Alias "SetPropA" (ByVal hwnd As Long, ByVal lpString As String, ByVal hData As Long) As Long
Private Declare Function GetProp Lib "user32.dll" Alias "GetPropA" (ByVal hwnd As Long, ByVal lpString As String) As Long
Private Declare Function RemoveProp Lib "user32.dll" Alias "RemovePropA" (ByVal hwnd As Long, ByVal lpString As String) As Long

Private Const PROPNAME_ID As String = "PropName_ID"

Private Type WndPrevProc
    hwnd      As Long
    lPrevProc As Long
    pDisp     As Object
    szFunc    As String
End Type

Private m_tWndProcArr() As WndPrevProc

Private Function checkArray() As Boolean
    If ((Not m_tWndProcArr) = -1) Then
        ReDim m_tWndProcArr(0)
        checkArray = False
    Else
        checkArray = True
    End If
End Function

Private Function getHWNDIndex(ByVal hwnd As Long) As Integer
    Dim i As Integer, nRet As Integer
    
    nRet = (-1)
    Call checkArray
    For i = 0 To UBound(m_tWndProcArr) Step 1
        If (m_tWndProcArr(i).hwnd = hwnd) Then
            nRet = i
            Exit For
        End If
    Next i
    getHWNDIndex = nRet
End Function

Private Function upSizeArray() As Integer
    ReDim Preserve m_tWndProcArr(UBound(m_tWndProcArr) + 1)
    upSizeArray = UBound(m_tWndProcArr)
End Function

Private Function getFreeIndex() As Integer
    Dim i As Integer, nRet As Integer
    
    nRet = (-1)
    Call checkArray
    For i = 0 To UBound(m_tWndProcArr) Step 1
        If (m_tWndProcArr(i).hwnd = 0) Then nRet = i: Exit For
    Next i
    If (nRet = -1) Then nRet = upSizeArray()
    getFreeIndex = nRet
End Function

Private Function updateArray(ByRef tWPP As WndPrevProc) As Integer
    Dim nIndx As Integer
    
    nIndx = getFreeIndex()
    m_tWndProcArr(nIndx) = tWPP
    updateArray = nIndx
End Function

'Public Function WndFunc(ByVal hWnd As Long, ByVal uiMsg As Long, ByVal wParam As Long, ByVal lParam As Long, ByRef vRet As Variant)
Public Function subclass(ByVal hwnd As Long, ByVal pDisp As Object, ByVal szWndFunc As String) As Boolean
    Dim tWPP As WndPrevProc
    
    subclass = False
    If (getHWNDIndex(hwnd) = -1) Then
        tWPP.hwnd = hwnd
        tWPP.lPrevProc = GetWindowLong(hwnd, GWL_WNDPROC)
        tWPP.szFunc = szWndFunc
        Set tWPP.pDisp = pDisp
        Call SetProp(hwnd, PROPNAME_ID, updateArray(tWPP))
        Call SetWindowLong(hwnd, GWL_WNDPROC, AddressOf mWndProc.wndProc)
        subclass = True
    End If
End Function

Public Function unsubclass(ByVal hwnd As Long) As Boolean
    Dim nIndx As Integer
    
    unsubclass = False
    nIndx = getHWNDIndex(hwnd)
    If (nIndx <> -1) Then
        Call SetWindowLong(hwnd, GWL_WNDPROC, m_tWndProcArr(nIndx).lPrevProc)
        Call RemoveProp(hwnd, PROPNAME_ID)
        With m_tWndProcArr(nIndx)
            .hwnd = 0
            .lPrevProc = 0
            Set .pDisp = Nothing
            .szFunc = vbNullString
        End With
        unsubclass = False
    End If
End Function

Public Function resetAll()
    Dim i As Integer
    
    Call checkArray
    For i = 0 To UBound(m_tWndProcArr) Step 1
        If (m_tWndProcArr(i).hwnd <> 0) Then
            With m_tWndProcArr(i)
                Call RemoveProp(.hwnd, PROPNAME_ID)
                Call SetWindowLong(.hwnd, GWL_WNDPROC, .lPrevProc)
            End With
        End If
    Next i
    Erase m_tWndProcArr
End Function

Public Function wndProc(ByVal hwnd As Long, ByVal uiMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Dim vRet As Variant
    
    With m_tWndProcArr(GetProp(hwnd, PROPNAME_ID))
        vRet = Empty
        Call Interaction.CallByName(.pDisp, .szFunc, VbMethod, hwnd, uiMsg, wParam, lParam, vRet)
        If (Not IsEmpty(vRet)) Then
            wndProc = CLng(vRet)
        Else
            wndProc = CallWindowProc(.lPrevProc, hwnd, uiMsg, wParam, lParam)
        End If
    End With
End Function

Public Function callWndProc(ByVal hwnd As Long, ByVal uiMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Dim lpProc As Long, nIndx As Integer
    
    nIndx = getHWNDIndex(hwnd)
    If (nIndx <> -1) Then
        callWndProc = CallWindowProc(m_tWndProcArr(nIndx).lPrevProc, hwnd, uiMsg, wParam, lParam)
        Exit Function
    End If
    callWndProc = 0
End Function












